package org.processmining.models.connections.bpmn.analysis.pn;

import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.models.flexiblemodel.Flex;
import org.processmining.models.graphbased.directed.bpmn.BPMNDiagram;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.plugins.bpmn.analysis.pn.data.BPMNAnalysisDataList;
import org.processmining.plugins.petrinet.replayresult.PNRepResult;

/**
 * @author ibayraktar
 * 
 */
public class BPMNAnalysisConnection extends AbstractConnection {
	static public final String BPMNDiagram = "BPMNDiagram";
	static public final String PetriNet = "Petri net";
	static public final String FLEX = "Flex";
	static public final String BPMN_FLEX_NODE_MAP = "BPMN_FLEX_NODE_MAP";
	static public final String STARTTASKNODESET = "StartTaskNodesSet";
	static public final String LOG = "Log";
	static public final String BPMNAnalysisList = "BPMNAnalysisList";
	static public final String PNReplayResult = "PNReplayResult";

	public BPMNAnalysisConnection(String label, BPMNDiagram bpmnDiagram, Petrinet petriNet, Flex flex, BPMNAnalysisDataList BPMNAnalysisDataList,
			PNRepResult replay) {
		super(label);
		put(FLEX, flex);
		put(BPMNDiagram, bpmnDiagram);
		put(PetriNet, petriNet);
		put(BPMNAnalysisList, BPMNAnalysisDataList);
		put(PNReplayResult, replay);
	}
}