package org.processmining.plugins.bpmn.analysis;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.flexiblemodel.Flex;
import org.processmining.models.graphbased.directed.bpmn.BPMNDiagram;
import org.processmining.plugins.bpmn.analysis.data.BPMNAnalysisDataList;


@Plugin(name = "BPMN Analysis",
		parameterLabels = { "Log", "Process Model" },
		returnLabels = { "BPMN Model without Swimlanes", "BPMN Model with Swimlanes", "BPMN Analysis Data List" }, 
		returnTypes = { BPMNDiagram.class, BPMNDiagram.class, BPMNAnalysisDataList.class }, 
		userAccessible = true, 
		help = "BPMN Analysis")
public class BPMNAnalysisPlugin extends BPMNAnalysis {
	
	@UITopiaVariant(uiLabel = "BPMN Analysis", affiliation = UITopiaVariant.EHV, author = "I. Bayraktar", email = "ib@processuniverse.net", website = "http://www.processuniverse.net")
	@PluginVariant(variantLabel = "BPMN Analysis", requiredParameterLabels = { 0, 1 })
	public Object[] bpmnAnalysis(final UIPluginContext context, XLog log, Flex originalModel) {
		return super.bpmnAnalysis(context, log, originalModel);
	}

	@PluginVariant(variantLabel = "BPMN Analysis with a C-Net and a Log", requiredParameterLabels = { 0, 1 })
	public Object[] bpmnAnalysis(final PluginContext context, XLog log, Flex originalModel) {
		return super.bpmnAnalysis(context, log, originalModel);
	}
}
