/**
 * 
 */
package org.processmining.plugins.bpmn.analysis.decorators;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;

/**
 * @author ibayraktar
 * 
 */
public class ActivityDecoratorData {
	private String name;

	private int frequency = 0;
	private int unfinishedActivityFrequency = 0;
	private int cancelledFrequency = 0;

	private double caseInvolvementRatio = 0;

	private double avgSynchTime = Double.NaN;
	private double avgWorkingTime = Double.NaN;
	private double avgWaitingTime = Double.NaN;
	private double avgTotalTime = Double.NaN;

	private double avgSynchTimeRatio = 1;

	private Color workingColor = Color.GREEN;
	private Color waitColor = Color.GREEN;
	private Color totalColor = Color.GREEN;
	private Color syncColor = Color.GREEN;

	private List<String> performers = new ArrayList<String>();

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name
	 *            the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	public double getAvgSynchTimeRatio() {
		return avgSynchTimeRatio;
	}

	public void setAvgSynchTimeRatio(double avgSynchTimeRatio) {
		this.avgSynchTimeRatio = avgSynchTimeRatio;
	}

	/**
	 * @return the frequency
	 */
	public int getFrequency() {
		return frequency;
	}

	/**
	 * @param frequency
	 *            the frequency to set
	 */
	public void setFrequency(int frequency) {
		this.frequency = frequency;
	}

	public int getCancelledFrequency() {
		return cancelledFrequency;
	}

	public void setCancelledFrequency(int cancelledFrequency) {
		this.cancelledFrequency = cancelledFrequency;
	}

	/**
	 * @return the avgWorkingTime
	 */
	public double getAvgWorkingTime() {
		return avgWorkingTime;
	}

	/**
	 * @param avgWorkingTime
	 *            the avgWorkingTime to set
	 */
	public void setAvgWorkingTime(double avgWorkingTime) {
		this.avgWorkingTime = avgWorkingTime;
	}

	public double getAvgSynchTime() {
		return avgSynchTime;
	}

	public void setAvgSynchTime(double avgSynchTime) {
		this.avgSynchTime = avgSynchTime;
	}

	public double getAvgWaitingTime() {
		return avgWaitingTime;
	}

	public void setAvgWaitingTime(double avgWaitingTime) {
		this.avgWaitingTime = avgWaitingTime;
	}

	public double getAvgTotalTime() {
		return avgTotalTime;
	}

	public void setAvgTotalTime(double avgTotalTime) {
		this.avgTotalTime = avgTotalTime;
	}

	/**
	 * @return the workingColor
	 */
	public Color getWorkingColor() {
		return workingColor;
	}

	/**
	 * @param workingColor
	 *            the workingColor to set
	 */
	public void setWorkingColor(Color workingColor) {
		this.workingColor = workingColor;
	}

	/**
	 * @return the waitColor
	 */
	public Color getWaitColor() {
		return waitColor;
	}

	/**
	 * @param waitColor
	 *            the waitColor to set
	 */
	public void setWaitColor(Color waitColor) {
		this.waitColor = waitColor;
	}

	public Color getTotalColor() {
		return totalColor;
	}

	public void setTotalColor(Color totalColor) {
		this.totalColor = totalColor;
	}

	/**
	 * @return the syncColor
	 */
	public Color getSyncColor() {
		return syncColor;
	}

	/**
	 * @return the caseInvolvementRatio
	 */
	public double getCaseInvolvementRatio() {
		return caseInvolvementRatio;
	}

	/**
	 * @param caseInvolvementRatio
	 *            the caseInvolvementRatio to set
	 */
	public void setCaseInvolvementRatio(double caseInvolvementRatio) {
		this.caseInvolvementRatio = caseInvolvementRatio;
	}

	/**
	 * @param syncColor
	 *            the syncColor to set
	 */
	public void setSyncColor(Color syncColor) {
		this.syncColor = syncColor;
	}

	public void incFrequency() {
		this.frequency++;
	}

	public String getLabel() {
		return name;
	}

	/**
	 * @return the unfinishedActivityFrequency
	 */
	public int getUnfinishedActivityFrequency() {
		return unfinishedActivityFrequency;
	}

	/**
	 * @param unfinishedActivityFrequency
	 *            the unfinishedActivityFrequency to set
	 */
	public void setUnfinishedActivityFrequency(int unfinishedActivityFrequency) {
		this.unfinishedActivityFrequency = unfinishedActivityFrequency;
	}

	public List<String> getPerformers() {
		return performers;
	}

	public void setPerformers(List<String> performers) {
		this.performers = performers;
	}

}
