/**
 * 
 */
package org.processmining.plugins.bpmn.analysis.decorators;

import java.awt.BasicStroke;
import java.awt.Graphics2D;
import java.text.NumberFormat;

import org.processmining.models.graphbased.directed.bpmn.elements.IGraphElementDecoration;

/**
 * @author ibayraktar
 * 
 */
public class EventDecorator implements IGraphElementDecoration {
	/**
	 * GUI RELATED VARIABLES
	 */
	public static final int PADDINGTOLEFT = 6;
	public static final int PADDINGFROMTOP = 3;

	// utility
	private final NumberFormat nf;

	// visualization data
	EventDecoratorData decor = null;

	// for this node, no information can be obtained by replaying
	public EventDecorator() {
		nf = null;
	}

	public EventDecorator(EventDecoratorData decor) {
		// init utility
		nf = NumberFormat.getInstance();
		nf.setMaximumFractionDigits(2);

		// init data
		this.decor = decor;
	}

	public void decorate(Graphics2D g2d, double x, double y, double width, double height) {
		
		// general stroke
		BasicStroke stroke = new BasicStroke((float) 1.0);
		g2d.setStroke(stroke);

		/**
		 * Label frequency and also throughput time
		 */
		// String textFrequency = getAggregatedEventClassFreq() + "/" + (getAggregatedEventClassFreq() + getUnfinishedActivityFrequency());
		// number of activity instances which is encountered in this node (note that this is different than activation frequency!)
		g2d.drawString(String.valueOf(decor.getFrequency()), Math.round((width/2)) - PADDINGTOLEFT , Math.round(height/2)+PADDINGFROMTOP);

	}

	public EventDecoratorData getDecor() {
		return decor;
	}

	public void setDecor(EventDecoratorData decor) {
		this.decor = decor;
	}
	
}
