/**
 * 
 */
package org.processmining.plugins.bpmn.analysis.decorators;

import java.awt.BasicStroke;
import java.awt.Graphics2D;
import java.text.NumberFormat;

import org.processmining.models.graphbased.directed.bpmn.elements.IGraphElementDecoration;

/**
 * @author ibayraktar
 * 
 */
public class GatewayDecorator implements IGraphElementDecoration {
	/**
	 * GUI RELATED VARIABLES
	 */
	public static final int PADDINGTOLEFT = 25;
	public static final int PADDINGFROMTOP = 3;
	
	private NumberFormat nf;
	// visualization data
	GatewayDecoratorData decor = null;

	// for this node, no information can be obtained by replaying
	public GatewayDecorator() {
	}

	public GatewayDecorator(GatewayDecoratorData decor) {
		this.decor = decor;
		nf = NumberFormat.getInstance();
		nf.setMaximumFractionDigits(2);

	}

	public void decorate(Graphics2D g2d, double x, double y, double width, double height) {
		
		// general stroke
		BasicStroke stroke = new BasicStroke((float) 1.0);
		g2d.setStroke(stroke);
		/**
		 * Label frequency and also throughput time
		 */
		
		/**
		 * Label frequency
		 */
		g2d.drawString("#"+String.valueOf(decor.getFrequency()), Math.round((width+x)) - PADDINGTOLEFT-3 , Math.round(height/2)+PADDINGFROMTOP);
		/**
		 * Draw percentage/probability freq of the node 
		 */
		g2d.drawString("%"+String.valueOf(nf.format(100*decor.getCaseInvolvementRatio())),Math.round((x)) + PADDINGTOLEFT+3 , Math.round(height/2)+PADDINGFROMTOP);
		
	}

	public GatewayDecoratorData getDecor() {
		return decor;
	}

	public void setDecor(GatewayDecoratorData decor) {
		this.decor = decor;
	}
	
}
