package org.processmining.plugins.bpmn.analysis.pn.data;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.processmining.framework.util.Pair;
import org.processmining.models.graphbased.directed.DirectedGraphNode;
import org.processmining.models.graphbased.directed.bpmn.elements.Activity;
import org.processmining.models.graphbased.directed.bpmn.elements.Swimlane;
import org.processmining.models.graphbased.directed.socialnetwork.SocialNetwork;
import org.processmining.plugins.bpmn.analysis.utils.Triple;
import org.processmining.plugins.flex.replayresult.performance.FlexPerfRepInfo;
import org.processmining.plugins.petrinet.replayresult.StepTypes;

public class BPMNAnalysisData {
	private String description;
	private String arrivalRate = "0.0";
	private int noOfResources = 0;
	private FlexPerfRepInfo perfRepInfo;
	private ConformanceInfo conformanceInfo;
	private Pair<List<Object>, List<StepTypes>> conformanceView = null;

	//USER INFO
	private boolean doesContainUserInfo=false;
	private SocialNetwork WT4CompleteLog;
	private SocialNetwork ST4CompleteLog;
	private SocialNetwork HoW4CompleteLog;
	private Map<Activity, SocialNetwork> activityBasedHoWSocialNetworkList = new HashMap<Activity, SocialNetwork>();
	private Map<Activity, SocialNetwork> activityBasedWTSocialNetworkList = new HashMap<Activity, SocialNetwork>();
	private Map<Activity, SocialNetwork> activityBasedSTSocialNetworkList = new HashMap<Activity, SocialNetwork>();
	private Map<DirectedGraphNode, List<Triple<String, String, Integer>>> selectedActivityUTMatrixList = new HashMap<DirectedGraphNode, List<Triple<String, String, Integer>>>();
	private Map<Swimlane, SocialNetwork> swimlaneBasedWTSocialNetworkList = new HashMap<Swimlane, SocialNetwork>();
	private Map<Swimlane, SocialNetwork> swimlaneBasedSTSocialNetworkList = new HashMap<Swimlane, SocialNetwork>();
	private Map<Swimlane, SocialNetwork> swimlaneBasedHoWSocialNetworkList = new HashMap<Swimlane, SocialNetwork>();
	private Map<DirectedGraphNode, List<Triple<String, String, Integer>>> selectedSwimlaneUTMatrixList = new HashMap<DirectedGraphNode, List<Triple<String, String, Integer>>>();
	private Map<Activity, Integer> numberOfUsersPerTaskMap = new HashMap<Activity, Integer>();
	private Map<Swimlane, Integer> numberOfUsersPerSwimlaneMap = new HashMap<Swimlane, Integer>();
	private Map<String, Map<String, Integer>> userActivityPercentageMap = new HashMap<String, Map<String, Integer>>();
	private Map<DirectedGraphNode, Set<String>> selectedNodeUTMatrixSortedHeaderMap = new HashMap<DirectedGraphNode, Set<String>>();
	private Map<String, List<String>> swimlaneUserListMap = new HashMap<String, List<String>>();
	private Map<String, List<String>> activityUserListMap = new HashMap<String, List<String>>();
	
	public Map<DirectedGraphNode, Set<String>> getSelectedNodeUTMatrixSortedHeaderMap() {
		return selectedNodeUTMatrixSortedHeaderMap;
	}

	public String getDescription() {
		return description;
	}

	public String getArrivalRate() {
		return arrivalRate;
	}

	public void setArrivalRate(String arrivalRate) {
		this.arrivalRate = arrivalRate;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public FlexPerfRepInfo getPerfRepInfo() {
		return perfRepInfo;
	}

	public void setPerfRepInfo(FlexPerfRepInfo flexPerfRepResult4EachSyncReplayResult) {
		this.perfRepInfo = flexPerfRepResult4EachSyncReplayResult;
	}

	public ConformanceInfo getConformanceInfo() {
		return conformanceInfo;
	}

	public void setConformanceInfo(ConformanceInfo conformanceInfo) {
		this.conformanceInfo = conformanceInfo;
	}
	
	
	public boolean doesContainUserInfo() {
		return doesContainUserInfo;
	}

	public void setDoesContainUserInfo(boolean doesContainUserInfo) {
		this.doesContainUserInfo = doesContainUserInfo;
	}

	public SocialNetwork getHoW4CompleteLog() {
		return HoW4CompleteLog;
	}

	public void setHoW4CompleteLog(SocialNetwork hoW4CompleteLog) {
		HoW4CompleteLog = hoW4CompleteLog;
	}

	public SocialNetwork getWT4CompleteLog() {
		return WT4CompleteLog;
	}

	public void setWT4CompleteLog(SocialNetwork wT4CompleteLog) {
		WT4CompleteLog = wT4CompleteLog;
	}

	public SocialNetwork getST4CompleteLog() {
		return ST4CompleteLog;
	}

	public void setST4CompleteLog(SocialNetwork sT4CompleteLog) {
		ST4CompleteLog = sT4CompleteLog;
	}

	public Map<Activity, SocialNetwork> getActivityBasedHoWSocialNetworkList() {
		return activityBasedHoWSocialNetworkList;
	}

	public void setActivityBasedHoWSocialNetworkList(Map<Activity, SocialNetwork> activityBasedHoWSocialNetworkList) {
		this.activityBasedHoWSocialNetworkList = activityBasedHoWSocialNetworkList;
	}

	public Map<Activity, SocialNetwork> getActivityBasedWTSocialNetworkList() {
		return activityBasedWTSocialNetworkList;
	}

	public void setActivityBasedWTSocialNetworkList(Map<Activity, SocialNetwork> activityBasedWTSocialNetworkList) {
		this.activityBasedWTSocialNetworkList = activityBasedWTSocialNetworkList;
	}

	public Map<Activity, SocialNetwork> getActivityBasedSTSocialNetworkList() {
		return activityBasedSTSocialNetworkList;
	}

	public void setActivityBasedSTSocialNetworkList(Map<Activity, SocialNetwork> activityBasedSTSocialNetworkList) {
		this.activityBasedSTSocialNetworkList = activityBasedSTSocialNetworkList;
	}

	public Map<Swimlane, SocialNetwork> getSwimlaneBasedWTSocialNetworkList() {
		return swimlaneBasedWTSocialNetworkList;
	}

	public void setSwimlaneBasedWTSocialNetworkList(Map<Swimlane, SocialNetwork> swimlaneBasedWTSocialNetworkList) {
		this.swimlaneBasedWTSocialNetworkList = swimlaneBasedWTSocialNetworkList;
	}

	public Map<Swimlane, SocialNetwork> getSwimlaneBasedSTSocialNetworkList() {
		return swimlaneBasedSTSocialNetworkList;
	}

	public void setSwimlaneBasedSTSocialNetworkList(Map<Swimlane, SocialNetwork> swimlaneBasedSTSocialNetworkList) {
		this.swimlaneBasedSTSocialNetworkList = swimlaneBasedSTSocialNetworkList;
	}

	public Map<Swimlane, SocialNetwork> getSwimlaneBasedHoWSocialNetworkList() {
		return swimlaneBasedHoWSocialNetworkList;
	}

	public void setSwimlaneBasedHoWSocialNetworkList(Map<Swimlane, SocialNetwork> swimlaneBasedHoWSocialNetworkList) {
		this.swimlaneBasedHoWSocialNetworkList = swimlaneBasedHoWSocialNetworkList;
	}

	public Map<DirectedGraphNode, List<Triple<String, String, Integer>>> getSelectedActivityUTMatrixList() {
		return selectedActivityUTMatrixList;
	}

	public void setSelectedActivityUTMatrixList(
			Map<DirectedGraphNode, List<Triple<String, String, Integer>>> selectedActivityUTMatrixList) {
		this.selectedActivityUTMatrixList = selectedActivityUTMatrixList;
	}

	public Map<DirectedGraphNode, List<Triple<String, String, Integer>>> getSelectedSwimlaneUTMatrixList() {
		return selectedSwimlaneUTMatrixList;
	}

	public void setSelectedSwimlaneUTMatrixList(
			Map<DirectedGraphNode, List<Triple<String, String, Integer>>> selectedSwimlaneUTMatrixList) {
		this.selectedSwimlaneUTMatrixList = selectedSwimlaneUTMatrixList;
	}

	public int getNoOfResources() {
		return noOfResources;
	}

	public void setNoOfResources(int noOfResources) {
		this.noOfResources = noOfResources;
	}

	public Map<Activity, Integer> getNumberOfUsersPerTaskMap() {
		return numberOfUsersPerTaskMap;
	}

	public void setNumberOfUsersPerTaskMap(Map<Activity, Integer> numberOfUsersPerTaskMap) {
		this.numberOfUsersPerTaskMap = numberOfUsersPerTaskMap;
	}

	public Map<Swimlane, Integer> getNumberOfUsersPerSwimlaneMap() {
		return numberOfUsersPerSwimlaneMap;
	}

	public void setNumberOfUsersPerSwimlaneMap(Map<Swimlane, Integer> numberOfUsersPerSwimlaneMap) {
		this.numberOfUsersPerSwimlaneMap = numberOfUsersPerSwimlaneMap;
	}

	public Map<String, Map<String, Integer>> getUserActivityPercentageMap() {
		return userActivityPercentageMap;
	}

	public void setUserActivityPercentageMap(Map<String, Map<String, Integer>> userActivityPercentageMap) {
		this.userActivityPercentageMap = userActivityPercentageMap;
	}

	public void setSelectedNodeUTMatrixSortedHeaderMap(
			Map<DirectedGraphNode, Set<String>> selectedNodeUTMatrixSortedHeaderMap) {
		this.selectedNodeUTMatrixSortedHeaderMap = selectedNodeUTMatrixSortedHeaderMap;
	}

	public Map<String, List<String>> getSwimlaneUserListMap() {
		return swimlaneUserListMap;
	}

	public void setSwimlaneUserListMap(Map<String, List<String>> swimlaneUserListMap) {
		this.swimlaneUserListMap = swimlaneUserListMap;
	}

	public Map<String, List<String>> getActivityUserListMap() {
		return activityUserListMap;
	}

	public void setActivityUserListMap(Map<String, List<String>> activityUserListMap) {
		this.activityUserListMap = activityUserListMap;
	}

	public Pair<List<Object>, List<org.processmining.plugins.petrinet.replayresult.StepTypes>> getConformanceView() {
		return conformanceView;
	}

	public void setConformanceView(Pair<List<Object>, List<org.processmining.plugins.petrinet.replayresult.StepTypes>> conformanceView) {
		this.conformanceView = conformanceView;
	}

}
