/**
 * 
 */
package org.processmining.plugins.bpmn.analysis.pn.data;

import java.util.Map;

import org.processmining.models.graphbased.directed.bpmn.elements.Activity;

/**
 * @author ibayraktar
 * 
 */
public class ConformanceInfo {
	private double fitness;
	private double minFitness;
	private double maxFitness;
	private int totalNumberOfLogMoves;
	private int totalNumberOfModelMoves;
	private int totalNumberOfSynchMoves;
	private Map<Activity, Integer> asynchMoves;
	private Map<Activity, Integer> synchMoves;
	
	public ConformanceInfo(double fitness, double minFitness, double maxFitness) {
		this.fitness = fitness;
		this.minFitness = minFitness;
		this.maxFitness = maxFitness;
	}
	public ConformanceInfo(double fitness, double minFitness, double maxFitness,
			int totalNumberOfLogMoves, int totalNumberOfModelMoves, int totalNumberOfSynchMoves) {
		this.fitness = fitness;
		this.minFitness = minFitness;
		this.maxFitness = maxFitness;
		this.totalNumberOfLogMoves = totalNumberOfLogMoves;
		this.totalNumberOfModelMoves = totalNumberOfModelMoves;
		this.totalNumberOfSynchMoves = totalNumberOfSynchMoves;
	}

	public double getFitness() {
		return fitness;
	}

	public void setFitness(double fitness) {
		this.fitness = fitness;
	}

	public double getMinFitness() {
		return minFitness;
	}

	public void setMinFitness(double minFitness) {
		this.minFitness = minFitness;
	}

	public double getMaxFitness() {
		return maxFitness;
	}

	public void setMaxFitness(double maxFitness) {
		this.maxFitness = maxFitness;
	}
	
	public  int getNumberOfLogMoves() {
		return totalNumberOfLogMoves;
	}
	public int getNumberOfModelMoves() {
		return totalNumberOfModelMoves;
	}
	public int getNumberOfSynchMoves() {
		return totalNumberOfSynchMoves;
	}

	public void setAsynchMoves(Map<Activity, Integer> asynchMoves) {
		this.asynchMoves = asynchMoves;
	}
	
	public Map<Activity, Integer> getAsynchMoves() {
		return asynchMoves;
	}
	
	public void setSynchMoves(Map<Activity, Integer> synchMoves) {
		this.synchMoves = synchMoves;
	}
	
	public Map<Activity, Integer> getSynchMoves() {
		return synchMoves;
	}
}
