/**
 * 
 */
package org.processmining.plugins.bpmn.analysis.pn.decorators;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics2D;

import javax.swing.JLabel;

import org.processmining.models.graphbased.directed.bpmn.elements.IGraphElementDecoration;

/**
 * 
 * @author Anna Kalenkova (akalenkova@hse.ru)
 *
 */
public class ActivityDecorator implements IGraphElementDecoration {

	private long logModel;
	
	private long total;
	
	Long avgTime;
	
	Long avgMaxTime;
	
	public ActivityDecorator (long logModel, long total, Long avgTime, Long avgMaxTime) {
		
		this.logModel = logModel;
		this.total = total;
		this.avgTime = avgTime;
		this.avgMaxTime = avgMaxTime;
	}
	
	public void decorate(Graphics2D g2d, double x, double y, double width, double height) {
		
		
		//---
		g2d.setColor(new Color (76, 153, 0));
		
		g2d.drawRoundRect((int) x + 1, (int) y + (int) ((float) 2 / (float) 3 * height) + 2, 
				(int) (((float)(logModel) / (float)total)*width) - 2,
				(int) ((float) 1 / (float) 3 * height) - 3, 5, 5);
		g2d.fillRoundRect((int) x + 1, (int) y + (int) ((float) 2 / (float) 3 * height) + 2, 
				(int) (((float)(logModel) / (float)total)*width) - 2,
				(int) ((float) 1 / (float) 3 * height) - 3, 5, 5);
		
		//---
		g2d.setColor(Color.BLACK);
		int labelX = (int) Math.round((x + 1));
		int labelY = (int) Math.round(y + ((float) 2 / (float) 3 * height) + 2);
		int labelW = (int) Math.round(((float)(logModel) / (float)total) * width);
		int labelH = (int) Math.round(((float) 1 / (float) 3 * height) - 3);

		JLabel label = new JLabel(logModel + "");
		label.setPreferredSize(new Dimension(labelW, labelH));
		label.setSize(new Dimension(labelW, labelH));

		label.setFont(new Font(label.getFont().getFamily(), label.getFont().getStyle(), 8));
		label.setHorizontalAlignment(JLabel.CENTER);
		label.validate();
		label.paint(g2d.create(labelX, labelY, labelW, labelH));
		
		//---
		g2d.setColor(new Color (153, 0, 0));
		
		g2d.drawRoundRect((int)(((float)(logModel) / (float)total)*width),
				(int) y + (int) ((float) 2 / (float) 3 * height) + 2, 
				(int) (((float)(total-logModel) / (float)total)*width) - 1,
				(int) ((float) 1 / (float) 3 * height) - 3, 5, 5);
		g2d.fillRoundRect((int)(((float)(logModel) / (float)total)*width), (int) y + (int) ((float) 2 / (float) 3 * height) + 2, 
				(int) (((float)(total-logModel) / (float)total)*width) - 1,
				(int) ((float) 1 / (float) 3 * height) - 3, 5, 5);
		
		//---
		g2d.setColor(Color.BLACK);
		labelX = (int) Math.round((((float)(logModel) / (float)total)*width));
		labelY = (int) Math.round(y + (int) ((float) 2 / (float) 3 * height) + 2);
		labelW = (int) Math.round(((float)(total-logModel) / (float)total) * width - 1);
		labelH = (int) Math.round(((float) 1 / (float) 3 * height) - 3);

		JLabel label2 = new JLabel(total-logModel + "");
		label2.setPreferredSize(new Dimension(labelW, labelH));
		label2.setSize(new Dimension(labelW, labelH));

		label2.setFont(new Font(label2.getFont().getFamily(), label2.getFont().getStyle(), 8));
		label2.setHorizontalAlignment(JLabel.CENTER);
		label2.validate();
		label2.paint(g2d.create(labelX, labelY, labelW, labelH));
	
		//--------------ADDING PERFORAMNCE INFO---------------

		if (avgTime != null) {
			g2d.setColor(Color.BLACK);
			labelX = (int) Math.round(x);
			labelY = (int) Math.round(y);
			labelW = (int) Math.round(width);
			labelH = (int) Math.round(height);
	
			JLabel label3 = new JLabel(String.format("%d:%02d:%02d",
					avgTime / 3600000, (avgTime % 3600000) / 60000, (avgTime  % 60000 / 1000)));
			label3.setPreferredSize(new Dimension(labelW, labelH));
			label3.setSize(new Dimension(labelW, labelH));
	
			label3.setFont(new Font(label.getFont().getFamily(), label.getFont().getStyle(), 8));
			label3.setHorizontalAlignment(JLabel.CENTER);
			label3.validate();
			label3.paint(g2d.create(labelX, labelY, labelW, labelH));
		}
	}
}
