///***********************************************************
// * This software is part of the ProM package * http://www.processmining.org/ * *
// * Copyright (c) 2003-2006 TU/e Eindhoven * and is licensed under the * Common
// * Public License, Version 1.0 * by Eindhoven University of Technology *
// * Department of Information Systems * http://is.tm.tue.nl * *
// **********************************************************/
//
//package org.processmining.plugins.bpmn.analysis.pn.visualization;
//
//import java.awt.BorderLayout;
//import java.awt.Color;
//import java.awt.Dimension;
//import java.awt.GridLayout;
//import java.awt.Rectangle;
//import java.awt.event.ActionEvent;
//import java.awt.event.ActionListener;
//import java.text.NumberFormat;
//import java.util.Arrays;
//import java.util.Collection;
//import java.util.HashMap;
//import java.util.HashSet;
//import java.util.List;
//import java.util.Map;
//import java.util.Set;
//
//import javax.swing.BorderFactory;
//import javax.swing.JButton;
//import javax.swing.JComponent;
//import javax.swing.JLabel;
//import javax.swing.JPanel;
//import javax.swing.JScrollPane;
//import javax.swing.JSlider;
//import javax.swing.JSplitPane;
//import javax.swing.SwingConstants;
//import javax.swing.border.Border;
//import javax.swing.border.TitledBorder;
//import javax.swing.event.ChangeEvent;
//import javax.swing.event.ChangeListener;
//
//import org.processmining.framework.connections.ConnectionCannotBeObtained;
//import org.processmining.framework.connections.ConnectionManager;
//import org.processmining.framework.plugin.PluginContext;
//import org.processmining.framework.util.Pair;
//import org.processmining.framework.util.ui.scalableview.VerticalLabelUI;
//import org.processmining.framework.util.ui.scalableview.interaction.CompoundViewInteractionPanel;
//import org.processmining.models.connections.bpmn.analysis.pn.BPMNAnalysisConnection;
//import org.processmining.models.connections.flexiblemodel.FlexCodecConnection;
//import org.processmining.models.flexiblemodel.Flex;
//import org.processmining.models.flexiblemodel.FlexEdge;
//import org.processmining.models.flexiblemodel.FlexNode;
//import org.processmining.models.graphbased.AttributeMap;
//import org.processmining.models.graphbased.ViewSpecificAttributeMap;
//import org.processmining.models.graphbased.directed.bpmn.BPMNDiagram;
//import org.processmining.models.graphbased.directed.bpmn.BPMNEdge;
//import org.processmining.models.graphbased.directed.bpmn.BPMNNode;
//import org.processmining.models.graphbased.directed.bpmn.elements.Activity;
//import org.processmining.models.graphbased.directed.bpmn.elements.Event;
//import org.processmining.models.graphbased.directed.bpmn.elements.Event.EventType;
//import org.processmining.models.graphbased.directed.bpmn.elements.Flow;
//import org.processmining.models.graphbased.directed.bpmn.elements.Gateway;
//import org.processmining.models.graphbased.directed.bpmn.elements.Swimlane;
//import org.processmining.models.jgraph.ProMJGraph;
//import org.processmining.models.jgraph.ProMJGraphVisualizer;
//import org.processmining.models.jgraph.visualization.ProMJGraphPanel;
//import org.processmining.plugins.bpmn.analysis.pn.data.BPMNAnalysisData;
//import org.processmining.plugins.bpmn.analysis.pn.data.BPMNAnalysisDataList;
//import org.processmining.plugins.bpmn.analysis.pn.data.ConformanceInfo;
//import org.processmining.plugins.bpmn.analysis.pn.decorators.ActivityDecorator;
//import org.processmining.plugins.bpmn.analysis.pn.decorators.ActivityDecoratorData;
//import org.processmining.plugins.bpmn.analysis.pn.decorators.EventDecorator;
//import org.processmining.plugins.bpmn.analysis.pn.decorators.EventDecoratorData;
//import org.processmining.plugins.bpmn.analysis.pn.decorators.FlowDecorator;
//import org.processmining.plugins.bpmn.analysis.pn.decorators.FlowDecoratorData;
//import org.processmining.plugins.bpmn.analysis.pn.decorators.GatewayDecorator;
//import org.processmining.plugins.bpmn.analysis.pn.decorators.GatewayDecoratorData;
//import org.processmining.plugins.bpmn.analysis.utils.PerformanceUtils;
//import org.processmining.plugins.flex.replayer.util.FlexBinding;
//import org.processmining.plugins.flex.replayer.util.FlexCodec;
//import org.processmining.plugins.flex.replayresult.performance.CaseInstance;
//import org.processmining.plugins.flex.replayresult.performance.EdgeInstance;
//import org.processmining.plugins.flex.replayresult.performance.FlexBindingInstance;
//import org.processmining.plugins.flex.replayresult.performance.FlexPerfRepInfo;
//
//import com.fluxicon.slickerbox.factory.SlickerDecorator;
//import com.fluxicon.slickerbox.factory.SlickerFactory;
//
//public class BPMNAnalysisVisualizationPanel extends JPanel {
//	/**/
//	private static final long serialVersionUID = 5929578796370746442L;
//	/**/
//
//	// NODES
//	public final static int NODEWIDTH = 140;
//	public final static int NODEHEIGHT = 80;
//	public final static int MAXNODEADDITIONALWIDTH = 30;
//	public final static int UNVISITEDNODEWIDTH = 140;
//	public final static int UNVISITEDHEIGHT = 80;
//
//	// EDGES
//	public final static float NORMALLINEWIDTH = 0.5f;
//	public final static float MINARCWIDTH = 0.5f;
//	public final static float MAXARCADDITIONWIDTH = 0.5f;
//
//	private static final Border EMPTYBORDER = BorderFactory.createEmptyBorder(2, 5, 2, 5);
//	private NumberFormat nf = NumberFormat.getInstance();
//
//	protected SlickerFactory factory = SlickerFactory.instance();
//	protected SlickerDecorator decorator = SlickerDecorator.instance();
//
//	//Graph Panel
//	private JPanel graphPanel = null;
//	protected ProMJGraphPanel proMJGraphPanel;
//
//	//Interaction conformance performance Panels
//	private PerfConfInteractionPanel confPerfAnalysisPanel = null;
//	@SuppressWarnings("unused")
//	private PerfConfInteractionPanel swimlaneConfigurationPanel = null;
//
//	private JPanel perfPanel = new JPanel();
//	private JPanel confPanel = new JPanel();
//	private JButton[] projectionButton = null;
//
//
//	//labels in Interaction Panels
//	private JSlider swimlaneSlider;
//	private JLabel sliderMinValue, sliderMaxValue, sliderValue;
//
//	private JLabel frequencyJLabel, arrivalRateJLabel, avgThroughputJLabel, minThroughputJLabel, maxThroughputJLabel,
//			stdDevThroughputJLabel, modelLabel, logLabel, totalLabel, minFitnessJLabel = new JLabel(), maxFitnessJLabel = new JLabel();
//
//	private PluginContext context = null;
//
//	// reference to model and between models
//	private BPMNDiagram bpmn = null;
//	private Flex flex = null;
//	private FlexCodec codec = null;
//
//	protected ViewSpecificAttributeMap viewSpecificMap;
//
//	private Map<FlexNode, BPMNNode> flexBPMNNodeMapping = new HashMap<FlexNode, BPMNNode>();
//	private Map<BPMNNode, FlexNode> bpmnFlexNodeMapping = new HashMap<BPMNNode, FlexNode>();
//	private Map<FlexEdge<? extends FlexNode, ? extends FlexNode>, BPMNEdge<BPMNNode, BPMNNode>> flexBPMNEdgeMapping = new HashMap<FlexEdge<? extends FlexNode, ? extends FlexNode>, BPMNEdge<BPMNNode, BPMNNode>>();
//	private Map<BPMNEdge<BPMNNode, BPMNNode>, FlexEdge<? extends FlexNode, ? extends FlexNode>> bpmnFlexEdgeMapping = new HashMap<BPMNEdge<BPMNNode, BPMNNode>, FlexEdge<? extends FlexNode, ? extends FlexNode>>();
//
//	private BPMNAnalysisData selectedBPMNAnalysisData;
//	private BPMNAnalysisData firstBPMNAnalysisData;
//
//	public BPMNAnalysisVisualizationPanel(PluginContext context, BPMNAnalysisDataList dataList) {
//		this.context = context;
//		this.bpmn = dataList.getBPMNDiagram();
//		ViewSpecificAttributeMap p =new ViewSpecificAttributeMap();
//		p.putViewSpecific(bpmn, AttributeMap.SIZE, new Dimension(1000,1000));
//		this.proMJGraphPanel = ProMJGraphVisualizer.instance()
//				.visualizeGraphWithoutRememberingLayout(bpmn, p);
//		proMJGraphPanel.getGraph().setMinimumSize(new Dimension(1000,1000));
//		this.proMJGraphPanel = ProMJGraphVisualizer.instance()
//				.visualizeGraphWithoutRememberingLayout(bpmn, p);
//		this.viewSpecificMap = proMJGraphPanel.getGraph().getViewSpecificAttributes();
//
//		String message = "";
//		ConnectionManager conn = context.getConnectionManager();
//		try {
////			message = "BPMNAnalysisConnection";
////			BPMNAnalysisConnection BPMNConnection = conn
////					.getFirstConnection(BPMNAnalysisConnection.class, context, bpmn);
////
////			BPMNAnalysisDataList BPMNAnalysisList = (BPMNAnalysisDataList) BPMNConnection
////					.getObjectWithRole(BPMNAnalysisConnection.BPMNAnalysisList);
//			
//
//			this.flex = dataList.getFlex();
//
//			message = "FlexCodecConnection";
//			FlexCodecConnection codecConn = conn.getFirstConnection(FlexCodecConnection.class, context, flex);
//			this.codec = (FlexCodec) codecConn.getObjectWithRole(FlexCodecConnection.FLEXCODEC);
//
////			firstBPMNAnalysisData = BPMNAnalysisList.get(0);
////			this.selectedBPMNAnalysisData = firstBPMNAnalysisData;
//			fillFlexBPMNNodeEdgeMappings(bpmn, flex/*
//													 * ,
//													 * isFlexModelWithLifecycle
//													 * (flex)
//													 */);
//			initVisualization(dataList, proMJGraphPanel);
//			updatePanelsAndColorModel();
//		} catch (ConnectionCannotBeObtained e) {
//			e.printStackTrace();
//			System.out.println("Exception occured while obtaining " + message);
//		}
//
//	}
//
//	/*
//	 * private boolean isFlexModelWithLifecycle(Flex flex) { boolean b = false;
//	 * Set<String> flexNodeStringSet = new HashSet<String>(); Set<FlexNode>
//	 * nodes = flex.getNodes(); for (FlexNode flexNode : nodes) { if
//	 * (flexNode.getLabel().indexOf("+") != -1) { String name =
//	 * flexNode.getLabel().substring(0, flexNode.getLabel().indexOf("+"));
//	 * flexNodeStringSet.add(name); } } if (flexNodeStringSet.size() ==
//	 * nodes.size()) b = false; else b = true; return b; }
//	 */
//
//	public JComponent getVisualization() {
//		return this;
//	}
//
//	private void initVisualization(BPMNAnalysisDataList BPMNAnalysisList, ProMJGraphPanel proMJGraphPanel) {
//		// Legend Panel
//		LegendInteractionPanel legendInteractionPanel = new LegendInteractionPanel(proMJGraphPanel, "Legend");
//		proMJGraphPanel.addViewInteractionPanel(legendInteractionPanel, SwingConstants.NORTH);
//
//		selectedBPMNAnalysisData = BPMNAnalysisList.get(0);
//
//		if ((BPMNAnalysisList.get(0).getPerfRepInfo()) != null && !BPMNAnalysisList.get(0).getPerfRepInfo().getNodeInstancesMap().isEmpty()) {
//			//Init perfconf interaction panel
//			initConfPerfAnalysisPanel(proMJGraphPanel);
//			//get the longest 
//			int size = 0;
//			for (BPMNAnalysisData bpmnAnalysisData : BPMNAnalysisList) {
//				Pair<List<Object>, List<org.processmining.plugins.petrinet.replayresult.StepTypes>> pair = bpmnAnalysisData.getConformanceView();
//				if (pair != null) {
//					int pairSize = pair.getFirst().size();
//					if (size < pairSize) {
//						size = pairSize;
//					}
//				}
//			}
//			size = (size * ProcessInstanceConformanceView.elementWidth) + ProcessInstanceConformanceView.trackPadding;
//			JPanel topContainer = new JPanel(new BorderLayout(20, 20));
//			topContainer.setBackground(new Color(30, 30, 30));
//			JLabel projectionLabel = factory.createLabel("List of Paths for Performance Information Projection");
//			projectionLabel
//					.setToolTipText("Projecting time/probability and organizational information of individual paths");
//			SlickerDecorator.instance().decorate(projectionLabel);
//			projectionLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 16));
//			projectionLabel.setForeground(Color.WHITE);
//			projectionLabel.setSize(300, 30);
//			projectionLabel.setLocation(0, 0);
//			topContainer.add(projectionLabel, BorderLayout.NORTH);
//			//create projection panel
//			int confViewWidth = size > 200 ? size + 100 : 300;
//			JPanel allViewContainer = new JPanel(new BorderLayout(20, 20));
//			allViewContainer.setBorder(BorderFactory.createEmptyBorder());
//			allViewContainer.setBackground(new Color(30, 30, 30));
//			allViewContainer.setSize(new Dimension(confViewWidth, 60 + (BPMNAnalysisList.size() - 1) * 140));
//			allViewContainer.setPreferredSize(new Dimension(confViewWidth, 60 + (BPMNAnalysisList.size() - 1) * 140));
//			allViewContainer.setMinimumSize(new Dimension(confViewWidth, 60 + (BPMNAnalysisList.size() - 1) * 140));
//			allViewContainer.setMaximumSize(new Dimension(confViewWidth, 60 + (BPMNAnalysisList.size() - 1) * 140));
//			JPanel allView = new JPanel(new GridLayout(1, 1));
//			allView.setBorder(BorderFactory.createEmptyBorder());
//			allView.setBackground(new Color(30, 30, 30));
//			allView.setSize(new Dimension(confViewWidth, 60));
//			allView.setPreferredSize(new Dimension(confViewWidth, 60));
//			allView.setMinimumSize(new Dimension(confViewWidth, 60));
//			allView.setMaximumSize(new Dimension(confViewWidth, 60));
//			JPanel caseView = new JPanel(new GridLayout(0, 1, 20, 20));
//			caseView.setBorder(BorderFactory.createEmptyBorder());
//			caseView.setBackground(new Color(30, 30, 30));
//			projectionButton = new JButton[BPMNAnalysisList.size()];
//			int count = 0;
//			for (final BPMNAnalysisData bpmnAnalysisData : BPMNAnalysisList) {
//				if (count == 0) {
//					allView.add(addAllTracesProjectionViewPanel(bpmnAnalysisData, confViewWidth, count));
//				} else {
//					caseView.add(addProjectionViewPanel(bpmnAnalysisData, confViewWidth, count));
//				}
//				count++;
//			}
//			allViewContainer.add(allView, BorderLayout.NORTH);
//			allViewContainer.add(caseView, BorderLayout.CENTER);
//			topContainer.add(allViewContainer, BorderLayout.CENTER);
//			JScrollPane scp = new JScrollPane(topContainer, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
//					JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
//			scp.setSize(0, 0);
//			JPanel messagePanel = new JPanel();
//			messagePanel
//					.add(new JLabel(
//							"Please press a Project button on the left panel to project performance and conformance information"));
//			graphPanel = new JPanel(new BorderLayout());
//			graphPanel.add(messagePanel, BorderLayout.NORTH);
//			
//			proMJGraphPanel.getGraph().setMinimumSize(new Dimension(1000,1000));
//			this.proMJGraphPanel = ProMJGraphVisualizer.instance()
//					.visualizeGraphWithoutRememberingLayout(bpmn);
//			
//			
//			graphPanel.add(proMJGraphPanel, BorderLayout.CENTER);
//			JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, scp, graphPanel);
//			splitPane.setDividerLocation(0);
//			splitPane.setOneTouchExpandable(true);
//			setLayout(new BorderLayout());
//			this.add(splitPane, BorderLayout.CENTER);
//		} else {
//			JPanel messagePanel = new JPanel();
//			messagePanel.add(new JLabel("No reliable performance information is available!"));
//			graphPanel = new JPanel(new BorderLayout());
//			graphPanel.add(messagePanel, BorderLayout.NORTH);
//			graphPanel.add(proMJGraphPanel, BorderLayout.CENTER);
//			setLayout(new BorderLayout());
//			this.add(graphPanel, BorderLayout.CENTER);
//		}
//
//	}
//
//	private JPanel addProjectionViewPanel(final BPMNAnalysisData bpmnAnalysisData, int confViewWidth, int index) {
//		JPanel panelContainer = new JPanel(new BorderLayout());
//		panelContainer.setBackground(new Color(30, 30, 30));
//
//		panelContainer.setSize(confViewWidth, 120);
//		panelContainer.setPreferredSize(new Dimension(confViewWidth, 120));
//		panelContainer.setMinimumSize(new Dimension(confViewWidth, 120));
//		panelContainer.setMaximumSize(new Dimension(confViewWidth, 120));
//
//		TitledBorder title = BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.WHITE),
//				bpmnAnalysisData.getDescription());
//		title.setTitleColor(Color.WHITE);
//		panelContainer.setBorder(title);
//
//		Pair<List<Object>, List<org.processmining.plugins.petrinet.replayresult.StepTypes>> conformanceViewPairList = bpmnAnalysisData.getConformanceView();
//		ProcessInstanceConformanceView conformanceView = new ProcessInstanceConformanceView(
//				conformanceViewPairList.getFirst(), conformanceViewPairList.getSecond(), confViewWidth,
//				bpmnAnalysisData.getPerfRepInfo().getCaseInstance().getFrequency());
//
//		panelContainer.add(conformanceView, BorderLayout.CENTER);
//
//		JPanel projectionButtonPanel = new JPanel(new GridLayout(3, 1));
//		projectionButtonPanel.setBackground(new Color(30, 30, 30));
//
//		JLabel dummyLabel = factory.createLabel("");
//		JLabel dummyLabel2 = factory.createLabel("");
//
//		projectionButton[index] = factory.createButton("Project");
//		projectionButton[index].setSize(new Dimension(100, 30));
//		projectionButton[index].setPreferredSize(new Dimension(100, 30));
//		projectionButton[index].setMinimumSize(new Dimension(100, 30));
//		projectionButton[index].setMaximumSize(new Dimension(100, 30));
//		projectionButton[index].setBackground(new Color(30, 30, 30));
//		projectionButton[index].setForeground(Color.WHITE);
//
//		projectionButton[index].addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent e) {
//				//if the conformance value is < 1 than we need to update the graph
//				//else just project the performance
//
//				JButton sourceButton = (JButton) e.getSource();
//				String label = sourceButton.getText();
//
//				if (label.equals("Project")) {
//					for (JButton button : projectionButton) {
//						button.setText("Project");
//						button.repaint();
//					}
//
//					selectedBPMNAnalysisData = bpmnAnalysisData;
//					sourceButton.setText("Reset");
//					updatePanelsAndColorModel();
//				} else {
//					sourceButton.setText("Project");
//					//updatePanelsAndUnColorModel(bpmnAnalysisData);
//				}
//
//			}
//		});
//		projectionButtonPanel.add(dummyLabel);
//		projectionButtonPanel.add(projectionButton[index]);
//		projectionButtonPanel.add(dummyLabel2);
//		panelContainer.add(projectionButtonPanel, BorderLayout.LINE_END);
//
//		return panelContainer;
//	}
//
//	private JPanel addAllTracesProjectionViewPanel(final BPMNAnalysisData bpmnAnalysisData, int confViewWidth, int index) {
//		JPanel panelContainer = new JPanel(new BorderLayout(10, 10));
//		TitledBorder title = BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.WHITE),
//				bpmnAnalysisData.getDescription());
//		title.setTitleColor(Color.WHITE);
//		panelContainer.setBorder(title);
//		panelContainer.setBackground(new Color(30, 30, 30));
//		panelContainer.setSize(new Dimension(confViewWidth, 30));
//		panelContainer.setPreferredSize(new Dimension(confViewWidth, 30));
//		panelContainer.setMinimumSize(new Dimension(confViewWidth, 30));
//		panelContainer.setMaximumSize(new Dimension(confViewWidth, 30));
//
//		JPanel projectionButtonPanel = new JPanel(new GridLayout(1, 2));
//		projectionButtonPanel.setBackground(new Color(30, 30, 30));
//
//		projectionButton[index] = factory.createButton("Reset");
//		projectionButton[index].setBackground(new Color(30, 30, 30));
//		projectionButton[index].setForeground(Color.WHITE);
//		projectionButton[index].addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent e) {
//				//if the conformance value is < 1 than we need to update the graph
//				//else just project the performance
//
//				JButton sourceButton = (JButton) e.getSource();
//				String label = sourceButton.getText();
//
//				if (label.equals("Project")) {
//					for (JButton button : projectionButton) {
//						button.setText("Project");
//						button.repaint();
//					}
//					sourceButton.setText("Reset");
//					selectedBPMNAnalysisData = bpmnAnalysisData;
//					updatePanelsAndColorModel();
//				} else {
//					sourceButton.setText("Project");
//					//updatePanelsAndUnColorModel(bpmnAnalysisData);
//				}
//
//			}
//		});
//		projectionButton[index].setSize(100, 30);
//
//		JLabel dummyLabel = factory.createLabel("");
//		dummyLabel.setToolTipText(bpmnAnalysisData.getDescription());
//		dummyLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//		SlickerDecorator.instance().decorate(dummyLabel);
//		dummyLabel.setForeground(Color.WHITE);
//
//		projectionButtonPanel.add(projectionButton[index]);
//		projectionButtonPanel.add(dummyLabel);
//
//		panelContainer.add(projectionButtonPanel, BorderLayout.CENTER);
//		return panelContainer;
//	}
//
//	/**
//	 * Performance Conformance Information Panel
//	 */
//	private void initConfPerfAnalysisPanel(ProMJGraphPanel proMJGraphPanel) {
//		ConformanceInfo confResult = getSelectedBPMNAnalysisData().getConformanceInfo();
//		FlexPerfRepInfo perfResult = getSelectedBPMNAnalysisData().getPerfRepInfo();
//		CaseInstance caseInstance = perfResult.getCaseInstance();
//
//		perfPanel.removeAll();
//		perfPanel.setLayout(new GridLayout(0, 1));
//		perfPanel.setSize(300, 135);
//		perfPanel.setLocation(10, 10);
//		perfPanel.setBounds(10, 10, 300, 135);
//		JLabel perfLabel = new JLabel("Performance Related Information");
//		perfLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
//		perfLabel.setForeground(Color.WHITE);
//		perfLabel.setHorizontalAlignment(JLabel.LEFT);
//
//		frequencyJLabel = new JLabel("Num. of cases : " + caseInstance.getFrequency());
////		arrivalRateJLabel = new JLabel("Arrival rate : " + getSelectedBPMNAnalysisData().getArrivalRate());
//		avgThroughputJLabel = new JLabel("Avg. throughput time: "
//				+ PerformanceUtils.getSuitableTimeStr(caseInstance.getAvgTimeSpan()));
//		minThroughputJLabel = new JLabel("Min. throughput time : "
//				+ PerformanceUtils.getSuitableTimeStr(caseInstance.getMinTimeSpan()));
//		maxThroughputJLabel = new JLabel("Max. throughput time : "
//				+ PerformanceUtils.getSuitableTimeStr(caseInstance.getMaxTimeSpan()));
////		stdDevThroughputJLabel = new JLabel("Std. deviation throughput time : "
////				+ PerformanceUtils.getSuitableTimeStr(caseInstance.getStdDevTimeSpan()));
//
//		frequencyJLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//		//arrivalRateJLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//		avgThroughputJLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//		minThroughputJLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//		maxThroughputJLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//		//stdDevThroughputJLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//
//		frequencyJLabel.setBorder(EMPTYBORDER);
//		//arrivalRateJLabel.setBorder(EMPTYBORDER);
//		avgThroughputJLabel.setBorder(EMPTYBORDER);
//		minThroughputJLabel.setBorder(EMPTYBORDER);
//		maxThroughputJLabel.setBorder(EMPTYBORDER);
//		//stdDevThroughputJLabel.setBorder(EMPTYBORDER);
//
//		frequencyJLabel.setOpaque(false);
//		//arrivalRateJLabel.setOpaque(false);
//		avgThroughputJLabel.setOpaque(false);
//		minThroughputJLabel.setOpaque(false);
//		maxThroughputJLabel.setOpaque(false);
//		//stdDevThroughputJLabel.setOpaque(false);
//
//		SlickerDecorator.instance().decorate(frequencyJLabel);
//		//SlickerDecorator.instance().decorate(arrivalRateJLabel);
//		SlickerDecorator.instance().decorate(avgThroughputJLabel);
//		SlickerDecorator.instance().decorate(minThroughputJLabel);
//		SlickerDecorator.instance().decorate(maxThroughputJLabel);
//		//SlickerDecorator.instance().decorate(stdDevThroughputJLabel);
//
//		perfPanel.add(perfLabel);
//		perfPanel.add(frequencyJLabel);
//		//perfPanel.add(arrivalRateJLabel);
//		perfPanel.add(avgThroughputJLabel);
//		perfPanel.add(minThroughputJLabel);
//		perfPanel.add(maxThroughputJLabel);
//		//perfPanel.add(stdDevThroughputJLabel);
//
//		confPanel.removeAll();
//		confPanel.setLayout(new GridLayout(0, 1));
//		confPanel.setSize(300, 80);
//		confPanel.setLocation(10, 150);
//		confPanel.setBounds(10, 150, 300, 80);
//		JLabel confLabel = new JLabel("Conformance Related Information");
//		confLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
//		confLabel.setForeground(Color.WHITE);
//		confLabel.setHorizontalAlignment(JLabel.LEFT);
//		confPanel.add(confLabel);
//
////		fitnessLabel = new JLabel("Avg. Fitness (out of all cases) : %" + nf.format(confResult.getFitness() * 100));
////		fitnessLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
////		fitnessLabel.setBorder(EMPTYBORDER);
////		SlickerDecorator.instance().decorate(fitnessLabel);
////		confPanel.add(fitnessLabel);
//		
//		logLabel = new JLabel("Total number of asynchronous log moves : " + confResult.getNumberOfLogMoves());
//		logLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//		logLabel.setBorder(EMPTYBORDER);
//		SlickerDecorator.instance().decorate(logLabel);
//		confPanel.add(logLabel);
//		
//		modelLabel = new JLabel("Total number of asynchronous model moves : " + confResult.getNumberOfModelMoves());
//		modelLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//		modelLabel.setBorder(EMPTYBORDER);
//		SlickerDecorator.instance().decorate(modelLabel);
//		confPanel.add(modelLabel);
//		
//		totalLabel = new JLabel("Total number of synchronous moves : " + confResult.getNumberOfSynchMoves());
//		totalLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//		totalLabel.setBorder(EMPTYBORDER);
//		SlickerDecorator.instance().decorate(totalLabel);
//		confPanel.add(totalLabel);
//
//
//		if (confResult.getMinFitness() != 0) {
//			minFitnessJLabel = new JLabel("Min. Fitness (out of all paths) : %" + nf.format(confResult.getMinFitness()));
//			maxFitnessJLabel = new JLabel("Max. Fitness (out of all paths) : %" + nf.format(confResult.getMaxFitness()));
//
//			minFitnessJLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//			maxFitnessJLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//
//			minFitnessJLabel.setBorder(EMPTYBORDER);
//			maxFitnessJLabel.setBorder(EMPTYBORDER);
//
//			minFitnessJLabel.setOpaque(false);
//			maxFitnessJLabel.setOpaque(false);
//
//			SlickerDecorator.instance().decorate(minFitnessJLabel);
//			SlickerDecorator.instance().decorate(maxFitnessJLabel);
//
//			confPanel.add(minFitnessJLabel);
//			confPanel.add(maxFitnessJLabel);
//		}
//
//		confPerfAnalysisPanel = new PerfConfInteractionPanel(proMJGraphPanel, "Performance/Conformance", confPanel,
//				perfPanel, 320, 230, PerfConfInteractionPanel.RIGHT_UP);
//
//	}
//
//	/**
//	 * Update interactive panels and color the model
//	 */
//	private void updatePanelsAndColorModel() {
//		if ((getSelectedBPMNAnalysisData().getPerfRepInfo() != null) && !getSelectedBPMNAnalysisData().getPerfRepInfo().getNodeInstancesMap().isEmpty()) {
//			initConfPerfAnalysisPanel(proMJGraphPanel);
//			uncolorElements();
//			fillMapAndRefreshEdges(Color.LIGHT_GRAY);
//			colorElements();
//		}
//
//	}
//
//	public BPMNAnalysisData getSelectedBPMNAnalysisData() {
//		return selectedBPMNAnalysisData;
//	}
//
//	public void setSelectedBPMNAnalysisData(BPMNAnalysisData selectedBPMNAnalysisData) {
//		this.selectedBPMNAnalysisData = selectedBPMNAnalysisData;
//	}
//
//	private void fillFlexBPMNNodeEdgeMappings(BPMNDiagram bpmn, Flex flex/*
//																		 * ,
//																		 * boolean
//																		 * isFlexModelWithLifecycle
//																		 */) {
//
//		for (Activity activity : bpmn.getActivities()) {
//			for (FlexNode flexNode : flex.getNodes()) {
//				String flexLabel = flexNode.getLabel();
//				/* if (!isFlexModelWithLifecycle) { */
//				int index = flexLabel.indexOf("+");
//				if (index != -1) {
//					flexLabel = flexLabel.substring(0, index);
//
//				}
//				/* } */;
//				if (activity.getLabel().contains(flexLabel)) {
//					flexBPMNNodeMapping.put(flexNode, activity);
//					bpmnFlexNodeMapping.put(activity, flexNode);
//					break;
//				}
//			}
//		}
//
//		for (FlexEdge<? extends FlexNode, ? extends FlexNode> flexEdge : flex.getEdges()) {
//			for (Flow flow : bpmn.getFlows()) {
//				FlexNode tempTargetFlexNode = flexEdge.getTarget();
//				FlexNode tempSourceFlexNode = flexEdge.getSource();
//				BPMNNode tempTargetBPMNNode = flexBPMNNodeMapping.get(tempTargetFlexNode);
//				BPMNNode tempSourceBPMNNode = flexBPMNNodeMapping.get(tempSourceFlexNode);
//				BPMNNode tempTargetBPMNNode2 = flow.getTarget();
//				BPMNNode tempSourceBPMNNode2 = flow.getSource();
//				if ((tempTargetBPMNNode != null) && (tempSourceBPMNNode2 != null)
//						&& (tempTargetBPMNNode2 != null) && (tempSourceBPMNNode != null)) {
//					if (tempTargetBPMNNode.equals(tempTargetBPMNNode2) && tempSourceBPMNNode.equals(tempSourceBPMNNode2)) {
//						flexBPMNEdgeMapping.put(flexEdge, flow);
//						bpmnFlexEdgeMapping.put(flow, flexEdge);
//						break;
//					}
//				}
//			}
//		}
//
//	}
//
//	public void colorElements() {
//		ProMJGraph graph = proMJGraphPanel.getGraph();
//		graph.setBounds(new Rectangle(new Dimension(1000,1000)));
//		// DECOR ACTIVITIES
//		Map<Activity, ActivityDecoratorData> activityDecorationMap = decorActivities();
//		if (!activityDecorationMap.isEmpty()) {
//
//			// DECOR FLOWS
//			decorFlows(activityDecorationMap);
//
//			// DECOR EVENTS
//			Map<Event, EventDecoratorData> eventDecorationMap = decorEvents(activityDecorationMap);
//
//			// DECOR GATEWAYS
//			decorGateways(activityDecorationMap, eventDecorationMap);
//
//			// refresh the figure
//			graph.update(bpmn.getNodes());
//			graph.update(bpmn.getFlows());
//		
//			graphPanel.removeAll();
//			proMJGraphPanel = ProMJGraphVisualizer.instance().visualizeGraphWithoutRememberingLayout(bpmn);
//			BPMNAnalysisDataList BPMNAnalysisList = null;
//			try {
//				BPMNAnalysisConnection BPMNConnection = context.getConnectionManager()
//						.getFirstConnection(BPMNAnalysisConnection.class, context, bpmn);
//				BPMNAnalysisList = (BPMNAnalysisDataList) BPMNConnection
//					.getObjectWithRole(BPMNAnalysisConnection.BPMNAnalysisList);
//			} catch(Exception e) {
//				e.printStackTrace();
//			}
//			initVisualization(BPMNAnalysisList, proMJGraphPanel);
//		}
//	}
//
//	/*
//	 * Paint Activities
//	 */
//	private Map<Activity, ActivityDecoratorData> decorActivities() {
//
//		FlexPerfRepInfo perfResult = getSelectedBPMNAnalysisData().getPerfRepInfo();
//		
//		ConformanceInfo confInfo = getSelectedBPMNAnalysisData().getConformanceInfo();
//
//		// calculate performance values
//		Map<Activity, Double> workingTime = new HashMap<Activity, Double>(); // also store temporary frequency
//		Map<Activity, Double> waitingTime = new HashMap<Activity, Double>(); // also store temporary frequency
//		Map<Activity, Double> syncTime = new HashMap<Activity, Double>(); // also store temporary frequency
//
//		Map<Activity, Double> sumWorkingTime = new HashMap<Activity, Double>();
//		Map<Activity, Double> sumWaitingTime = new HashMap<Activity, Double>();
//		Map<Activity, Double> sumSyncTime = new HashMap<Activity, Double>();
//
//		Map<Activity, ActivityDecoratorData> activityDecorationMap = new HashMap<Activity, ActivityDecoratorData>();
//
//		// abuse flexBindingInstance to store node performance info
//
//		Map<Activity, Long> minWaitingTime = new HashMap<Activity, Long>();
//		Map<Activity, Long> maxWaitingTime = new HashMap<Activity, Long>();
//		Map<Activity, Long> minWorkingTime = new HashMap<Activity, Long>();
//		Map<Activity, Long> maxWorkingTime = new HashMap<Activity, Long>();
//		Map<Activity, Long> minSyncTime = new HashMap<Activity, Long>();
//		Map<Activity, Long> maxSyncTime = new HashMap<Activity, Long>();
//
//		Map<Short, Set<FlexBindingInstance>> nodeInstancesMap = perfResult.getNodeInstancesMap();
//		if (!nodeInstancesMap.isEmpty()) {
//			for (Short encodedFlexNode : nodeInstancesMap.keySet()) {
//				for (FlexBindingInstance bindingInstance : nodeInstancesMap.get(encodedFlexNode)) {
//					FlexBinding binding = codec.getFlexBindingFor(bindingInstance.getEncodedBinding());
//					short bindingEncodedNode = binding.getEncodedNode();
//					FlexNode flexNode = codec.decode(bindingEncodedNode);
//					Activity activityNode = (Activity) flexBPMNNodeMapping.get(flexNode);
//
//					ActivityDecoratorData decor = activityDecorationMap.get(activityNode);
//					if (decor == null) {
//						decor = new ActivityDecoratorData();
//						activityDecorationMap.put(activityNode, decor);
//					}
//					decor.setFrequency(decor.getFrequency() + bindingInstance.getFrequency());
//					/*
//					 * updateDecorSemantic(flexNode, decor, binding,
//					 * decor.getFrequency());
//					 * decor.setCancelledFrequency(perfResult.
//					 * getCancellationFrequency(bindingEncodedNode));
//					 */
//					if (sumWorkingTime.get(activityNode) != null) {
//						// working time
//						sumWorkingTime.put(
//								activityNode,
//								sumWorkingTime.get(activityNode)
//										+ (bindingInstance.getAvgWorkTime() * bindingInstance.getFrequency()));
//						workingTime.put(activityNode, bindingInstance.getFrequency() + workingTime.get(activityNode));
//
//						if (Double.compare(minWorkingTime.get(activityNode), bindingInstance.getMinWorkTime()) > 0) {
//							minWorkingTime.put(activityNode, bindingInstance.getMinWorkTime());
//						}
//						if (Double.compare(maxWorkingTime.get(activityNode), bindingInstance.getMaxWorkTime()) < 0) {
//							maxWorkingTime.put(activityNode, bindingInstance.getMaxWorkTime());
//						}
//
//					} else {
//						// working time for the first time
//						sumWorkingTime.put(activityNode,
//								bindingInstance.getAvgWorkTime() * bindingInstance.getFrequency());
//						workingTime.put(activityNode, (double) bindingInstance.getFrequency());
//						minWorkingTime.put(activityNode, bindingInstance.getMinWorkTime());
//						maxWorkingTime.put(activityNode, bindingInstance.getMaxWorkTime());
//
//					}
//
//					if (sumWaitingTime.get(activityNode) != null) {
//						// waiting time
//						sumWaitingTime.put(
//								activityNode,
//								sumWaitingTime.get(activityNode)
//										+ (bindingInstance.getAvgWaitTime() * bindingInstance.getFrequency()));
//						waitingTime.put(activityNode, bindingInstance.getFrequency() + waitingTime.get(activityNode));
//						if (Double.compare(minWaitingTime.get(activityNode), bindingInstance.getMinWaitTime()) > 0) {
//							minWaitingTime.put(activityNode, bindingInstance.getMinWaitTime());
//						}
//						if (Double.compare(maxWaitingTime.get(activityNode), bindingInstance.getMaxWaitTime()) < 0) {
//							maxWaitingTime.put(activityNode, bindingInstance.getMaxWaitTime());
//						}
//					} else {
//						// waiting time for the first time
//						sumWaitingTime.put(activityNode,
//								bindingInstance.getAvgWaitTime() * bindingInstance.getFrequency());
//						waitingTime.put(activityNode, (double) bindingInstance.getFrequency());
//						minWaitingTime.put(activityNode, bindingInstance.getMinWaitTime());
//						maxWaitingTime.put(activityNode, bindingInstance.getMaxWaitTime());
//					}
//
//					if (sumSyncTime.get(activityNode) != null) {
//						// sync time
//						sumSyncTime.put(activityNode, sumSyncTime.get(activityNode)
//								+ (bindingInstance.getAvgSyncTime() * bindingInstance.getFrequency()));
//						syncTime.put(activityNode, bindingInstance.getFrequency() + syncTime.get(activityNode));
//						if (Double.compare(minSyncTime.get(activityNode), bindingInstance.getMinSyncTime()) > 0) {
//							minSyncTime.put(activityNode, bindingInstance.getMinSyncTime());
//						}
//						if (Double.compare(maxSyncTime.get(activityNode), bindingInstance.getMaxSyncTime()) < 0) {
//							maxSyncTime.put(activityNode, bindingInstance.getMaxSyncTime());
//						}
//
//					} else {
//						// sync time for the first time
//						sumSyncTime
//								.put(activityNode, bindingInstance.getAvgSyncTime() * bindingInstance.getFrequency());
//						syncTime.put(activityNode, (double) bindingInstance.getFrequency());
//						minSyncTime.put(activityNode, bindingInstance.getMinSyncTime());
//						maxSyncTime.put(activityNode, bindingInstance.getMaxSyncTime());
//					}
//
//				}
//			}
//			Set<FlexNode> setAllNodes = codec.getFlexNodes();
//			Set<Double> sumNodeAvgWorkingTime = new HashSet<Double>();
//			Set<Double> sumNodeAvgWaitingTime = new HashSet<Double>();
//			Set<Double> sumNodeAvgTotalTime = new HashSet<Double>();
//			Set<Double> sumNodeAvgSyncTime = new HashSet<Double>();
//			int maxNodeFreq = Integer.MIN_VALUE;
//			int minNodeFreq = Integer.MAX_VALUE;
//			for (FlexNode flexNode : setAllNodes) {
//				Activity activityNode = (Activity) flexBPMNNodeMapping.get(flexNode);
//
//				if (workingTime.get(activityNode) != null) {
//					double freq = workingTime.get(activityNode);
//					double avg = sumWorkingTime.get(activityNode) / freq;
//
//					if (maxNodeFreq < activityDecorationMap.get(activityNode).getFrequency()) {
//						maxNodeFreq = activityDecorationMap.get(activityNode).getFrequency();
//					}
//					if (minNodeFreq > activityDecorationMap.get(activityNode).getFrequency()) {
//						minNodeFreq = activityDecorationMap.get(activityNode).getFrequency();
//					}
//
//					workingTime.put(activityNode, avg);
//					sumNodeAvgWorkingTime.add(avg);
//				} else {
//					workingTime.put(activityNode, Double.NaN);
//				}
//
//				if (waitingTime.get(activityNode) != null) {
//					double avg = sumWaitingTime.get(activityNode) / waitingTime.get(activityNode);
//					waitingTime.put(activityNode, avg);
//					sumNodeAvgWaitingTime.add(avg);
//				} else {
//					waitingTime.put(activityNode, Double.NaN);
//				}
//
//				if (workingTime.get(activityNode) != Double.NaN && waitingTime.get(activityNode) != Double.NaN) {
//					sumNodeAvgTotalTime.add(waitingTime.get(activityNode) + workingTime.get(activityNode));
//				}
//
//				if (syncTime.get(activityNode) != null) {
//					double avg = sumSyncTime.get(activityNode) / syncTime.get(activityNode);
//					syncTime.put(activityNode, avg);
//					sumNodeAvgSyncTime.add(avg);
//				} else {
//					syncTime.put(activityNode, Double.NaN);
//				}
//			}
//			// prepare color for sync, etc
//			// bound for working time
//			sumNodeAvgWorkingTime.remove(Double.NaN);
//			double lowBoundAvgWorking = (confInfo.getNumberOfSynchMoves()/5);
//			double upBoundAvgWorking = 4 * confInfo.getNumberOfSynchMoves()/5;
////			if (sumNodeAvgWorkingTime.size() > 1) {
////				double[] arrSumNodeAvgWorking = getSortedArrayFromSet(sumNodeAvgWorkingTime);
////				if (arrSumNodeAvgWorking.length >= 3) {
////					int indexLow = arrSumNodeAvgWorking.length / 3;
////					lowBoundAvgWorking = arrSumNodeAvgWorking[indexLow - 1];
////					upBoundAvgWorking = arrSumNodeAvgWorking[(indexLow * 2) - 1];
////				} else {
////					lowBoundAvgWorking = arrSumNodeAvgWorking[0];
////				}
////			}
//			// bound for waiting time
//			sumNodeAvgWaitingTime.remove(Double.NaN);
//			double lowBoundAvgWaiting = confInfo.getNumberOfModelMoves()/5;
//			double upBoundAvgWaiting = 4*confInfo.getNumberOfModelMoves()/5;
////			if (sumNodeAvgWaitingTime.size() > 1) {
////				double[] arrSumNodeAvgWaiting = getSortedArrayFromSet(sumNodeAvgWaitingTime);
////				if (arrSumNodeAvgWaiting.length >= 3) {
////					int indexLow = arrSumNodeAvgWaiting.length / 3;
////					lowBoundAvgWaiting = arrSumNodeAvgWaiting[indexLow - 1];
////					upBoundAvgWaiting = arrSumNodeAvgWaiting[(indexLow * 2) - 1];
////				} else {
////					lowBoundAvgWaiting = arrSumNodeAvgWaiting[0];
////				}
////
////			}
//			// bound for sync time
//			sumNodeAvgWorkingTime.remove(Double.NaN);
//			double lowBoundAvgSync = Double.POSITIVE_INFINITY;
//			double upBoundAvgSync = Double.POSITIVE_INFINITY;
//			if (sumNodeAvgSyncTime.size() > 1) {
//				double[] arrSumNodeAvgSync = getSortedArrayFromSet(sumNodeAvgSyncTime);
//				if (arrSumNodeAvgSync.length >= 3) {
//					int indexLow = arrSumNodeAvgSync.length / 3;
//					lowBoundAvgSync = arrSumNodeAvgSync[indexLow - 1];
//					upBoundAvgSync = arrSumNodeAvgSync[(indexLow * 2) - 1];
//				} else {
//					lowBoundAvgSync = arrSumNodeAvgSync[0];
//					upBoundAvgSync = arrSumNodeAvgSync[arrSumNodeAvgSync.length - 1];
//				}
//
//			} else if (sumNodeAvgSyncTime.size() == 1) {
//				lowBoundAvgSync = sumNodeAvgSyncTime.iterator().next().doubleValue();
//				upBoundAvgSync = lowBoundAvgSync;
//			}
//			// prepare color for total, etc
//			// bound for total time
//			double lowBoundAvgTotal = Double.POSITIVE_INFINITY;
//			double upBoundAvgTotal = Double.POSITIVE_INFINITY;
//			if (sumNodeAvgWorkingTime.size() > 1) {
//				double[] arrSumNodeAvgTotal = getSortedArrayFromSet(sumNodeAvgTotalTime);
//				if (arrSumNodeAvgTotal.length >= 3) {
//					int indexLow = arrSumNodeAvgTotal.length / 3;
//					lowBoundAvgTotal = arrSumNodeAvgTotal[indexLow - 1];
//					upBoundAvgTotal = arrSumNodeAvgTotal[(indexLow * 2) - 1];
//				} else {
//					lowBoundAvgTotal = arrSumNodeAvgTotal[0];
//				}
//
//			}
//			// decorate activity nodes
//			Map<Short, Integer> caseInvolvement = perfResult.getNodeCaseInvolvement();
//			CaseInstance caseInstance = perfResult.getCaseInstance();
//			Map<Short, Integer> unfinishedFrequency = perfResult.getUnfinishedFrequency();
//			double minMaxNodeDifference = upBoundAvgTotal - lowBoundAvgTotal; // for calculation of height
//			double widthRatio = 0;
//			if (minMaxNodeDifference != 0) {
//				widthRatio = MAXNODEADDITIONALWIDTH / minMaxNodeDifference;
//			}
//			//fill performer list to activity data object
//			Map<String, List<String>> activityUserListMap = getSelectedBPMNAnalysisData().getActivityUserListMap();
//			if (activityUserListMap != null) {
//				if (!activityUserListMap.isEmpty()) {
//					for (Activity node : bpmn.getActivities()) {
//						ActivityDecoratorData act = activityDecorationMap.get(node);
//						if (act != null) {
//							List<String> lst = activityUserListMap.get(node.getLabel());
//							act.setPerformers(lst);
//						}
//					}
//				}
//			}
//			//fill performance data to activity data object 		
//			for (Activity node : bpmn.getActivities()) {
//
//				viewSpecificMap.putViewSpecific(node, AttributeMap.FILLCOLOR, Color.LIGHT_GRAY);
//				viewSpecificMap.putViewSpecific(node, AttributeMap.SHOWLABEL, false);
//
//				ActivityDecoratorData nodeDecor = activityDecorationMap.get(node);
//				if (nodeDecor == null) {
//					nodeDecor = new ActivityDecoratorData();
//				}
//
//				short encodedNode = 0;
//				if(bpmnFlexNodeMapping.get(node) != null) {
//						encodedNode = codec.encode(bpmnFlexNodeMapping.get(node));
//				}
//				if (nodeDecor != null) {
//					if (caseInvolvement.get(encodedNode) != null) {
//						nodeDecor.setCaseInvolvementRatio((double) caseInvolvement.get(encodedNode)
//							/ (double) caseInstance.getFrequency());
//					} else {
//						nodeDecor.setCaseInvolvementRatio(0);
//					}
//					if(confInfo.getSynchMoves().get(node) != null) {
//						nodeDecor.setSyncModelColor(getColor(new Double(confInfo.getSynchMoves().get(node)), lowBoundAvgWorking, upBoundAvgWorking));
//					} else {
//						nodeDecor.setSyncModelColor(getColor(0.0, lowBoundAvgWorking, upBoundAvgWorking));
//					}
//					if(confInfo.getAsynchMoves().get(node) != null) {
//						nodeDecor.setAsyncColor(getColor(new Double(confInfo.getAsynchMoves().get(node)), lowBoundAvgWaiting, upBoundAvgWaiting));
//					} else {
//						nodeDecor.setAsyncColor(getColor(0.0, lowBoundAvgWaiting, upBoundAvgWaiting));
//					}
//					
//					nodeDecor.setTotalColor(Color.WHITE);
//					
//					if(syncTime.get(node) != null) {
//						nodeDecor.setSyncColor(getColor(syncTime.get(node), lowBoundAvgSync, upBoundAvgSync));
//					} else {
//						nodeDecor.setSyncColor(getColor(0.0, lowBoundAvgSync, upBoundAvgSync));
//					}
//					
////					if (Double.compare(Double.NaN, syncTime.get(node)) != 0
////							&& Double.compare(syncTime.get(node), 0.0) != 0
////							&& Double.compare(syncTime.get(node), 0.0) > 0
////							&& lowBoundAvgWaiting != Double.POSITIVE_INFINITY
////							&& upBoundAvgWaiting != Double.POSITIVE_INFINITY) {
////						double d = upBoundAvgSync - lowBoundAvgSync;
////						double d2 = syncTime.get(node) - lowBoundAvgSync;
////						nodeDecor.setAvgSynchTimeRatio((d > 0.0 && d != 0.0) ? (d2 / d) : 1.0);
////					}
//					if(waitingTime.get(node) != null) {	
//						nodeDecor.setAvgTotalTime(waitingTime.get(node));
//					} else {
//						nodeDecor.setAvgTotalTime(0);
//					}
//					
//					if(confInfo.getAsynchMoves().get(node) != null) {
//						nodeDecor.setAsyncModelMoves(confInfo.getAsynchMoves().get(node));
//					} else {
//						nodeDecor.setAsyncModelMoves(0);
//					}
//					if(confInfo.getSynchMoves().get(node) != null) {
//						nodeDecor.setSyncModelMoves(confInfo.getSynchMoves().get(node));
//					} else {
//						nodeDecor.setSyncModelMoves(0);
//					}
//					//nodeDecor.setAvgSynchTime(syncTime.get(node));
//
//					nodeDecor.setName(node.getLabel());
//
//					if (unfinishedFrequency.get(encodedNode) != null) {
//						nodeDecor.setUnfinishedActivityFrequency(unfinishedFrequency.get(encodedNode));
//					}
//					nodeDecor.setCancelledFrequency(perfResult.getCancellationFrequency(encodedNode));
//					node.setDecorator(new ActivityDecorator(nodeDecor));
//
//					double totalTimeDifference = nodeDecor.getAvgTotalTime() - lowBoundAvgTotal;
//					double nodeTimeDifference = (totalTimeDifference - lowBoundAvgTotal) > minMaxNodeDifference ? minMaxNodeDifference
//							: (totalTimeDifference - lowBoundAvgTotal);
//
//					viewSpecificMap.removeViewSpecific(node, AttributeMap.SIZE);
//					int additionalWidth = (int) (nodeTimeDifference * widthRatio);
//					additionalWidth = (additionalWidth > 0 ? additionalWidth : 0);
//					viewSpecificMap.putViewSpecific(node, AttributeMap.SIZE, new Dimension(NODEWIDTH + additionalWidth,
//							NODEHEIGHT));
////					StringBuffer additionalText = new StringBuffer("<html><table border=0>" + "<tr><td colspan=6><b>"
////							+ node.getLabel() + "</b><br/></td></tr>" + "<tr>"
////							+ "<td colspan=6><b>Waiting time</b></td>" + "</tr>" + "<tr>" + "<td>Avg.</td>" + "<td>"
////							+ PerformanceUtils.getSuitableTimeStr(waitingTime.get(node)) + "</td>" + "<td>Min.</td>"
////							+ "<td>" + PerformanceUtils.getSuitableTimeStr(minWaitingTime.get(node)) + " </td>"
////							+ "<td>Max.</td>" + "<td>" + PerformanceUtils.getSuitableTimeStr(maxWaitingTime.get(node))
////							+ "</td>" + "</tr>");
////					additionalText.append("<tr>" + "<td colspan=6><b>Working time</b></td></tr>" + "<tr>"
////							+ "<td>Avg.</td>" + "<td>" + PerformanceUtils.getSuitableTimeStr(workingTime.get(node))
////							+ "</td>" + "<td>Min.</td>" + "<td>"
////							+ PerformanceUtils.getSuitableTimeStr(minWorkingTime.get(node)) + "</td>" + "<td>Max.</td>"
////							+ "<td>" + PerformanceUtils.getSuitableTimeStr(maxWorkingTime.get(node)) + "</td>"
////							+ "</tr>");
////					additionalText.append("<tr>" + "<td colspan=6><b>Total time</b></td></tr>" + "<tr>"
////							+ "<td>Avg.</td>" + "<td>"
////							+ PerformanceUtils.getSuitableTimeStr(waitingTime.get(node) + workingTime.get(node))
////							+ "</td>" + "<td>Min.</td>" + "<td>"
////							+ PerformanceUtils.getSuitableTimeStr(minWaitingTime.get(node) + minWorkingTime.get(node))
////							+ "</td>" + "<td>Max.</td>" + "<td>"
////							+ PerformanceUtils.getSuitableTimeStr(maxWaitingTime.get(node) + maxWorkingTime.get(node))
////							+ "</td>" + "</tr>");
////
////					if (Double.compare(Double.NaN, nodeDecor.getAvgSynchTime()) != 0
////							&& Double.compare(0.0, nodeDecor.getAvgSynchTime()) < 0) {
////						additionalText.append("<tr><td colspan=6><b>Sync. time</b></td></tr>" + "<tr>	<td>Avg.</td>"
////								+ "<td>" + PerformanceUtils.getSuitableTimeStr(syncTime.get(node)) + "</td>"
////								+ "<td>Min.</td>" + "<td>" + PerformanceUtils.getSuitableTimeStr(minSyncTime.get(node))
////								+ "</td>" + "<td>Max.</td>" + "<td>"
////								+ PerformanceUtils.getSuitableTimeStr(maxSyncTime.get(node)) + "</td>" + "</tr>");
////
////					}
////
////					viewSpecificMap.putViewSpecific(node, AttributeMap.TOOLTIP, additionalText
////							.append("</table></html>").toString());
//				} 
//			}
//
//		}
//		return activityDecorationMap;
//	}
//
//	/*
//	 * Paint Flows
//	 */
//	private void decorFlows(Map<Activity, ActivityDecoratorData> activityDecorationMap) {
//		// find bound for edges (including frequency)
//		int minEdgeFreq = Integer.MAX_VALUE;
//		int maxEdgeFreq = Integer.MIN_VALUE;
//		Map<Pair<Short, Short>, EdgeInstance> instanceMap = getSelectedBPMNAnalysisData().getPerfRepInfo()
//				.getEdgeInstancesMap();
//		Set<Double> sumEdgeAvgMoveTime = new HashSet<Double>();
//
//		if (!instanceMap.isEmpty()) {
//			for (Pair<Short, Short> pair : instanceMap.keySet()) {
//				EdgeInstance edgeInstance = instanceMap.get(pair);
//				if (minEdgeFreq > edgeInstance.getFrequency()) {
//					minEdgeFreq = edgeInstance.getFrequency();
//				}
//				if (maxEdgeFreq < edgeInstance.getFrequency()) {
//					maxEdgeFreq = edgeInstance.getFrequency();
//				}
//				sumEdgeAvgMoveTime.add(edgeInstance.getAvgMoveTime());
//			}
//		} else {
//			minEdgeFreq = getSelectedBPMNAnalysisData().getPerfRepInfo().getCaseInstance().getFrequency();
//			maxEdgeFreq = getSelectedBPMNAnalysisData().getPerfRepInfo().getCaseInstance().getFrequency();
//		}
//		int minMaxEdgeDifference = maxEdgeFreq - minEdgeFreq;
//
//		for (FlexNode flexNode : flex.getNodes()) {
//			List<FlexNode> inNodes = PerformanceUtils.getFlexNodeList(flex, flexNode, false);
//			List<FlexNode> outNodes = PerformanceUtils.getFlexNodeList(flex, flexNode, true);
//
//			if (outNodes.size() == 0) {
//				// end event
//				// get correspondant bpmn node
//				BPMNNode bpmnNode = flexBPMNNodeMapping.get(flexNode);
//
//				// get edge to the gateway
//				if ((bpmn.getOutEdges(bpmnNode) != null) && (bpmn.getOutEdges(bpmnNode).size() > 0)) {
//					BPMNEdge<? extends BPMNNode, ? extends BPMNNode> outEdge = bpmn.getOutEdges(bpmnNode).iterator().next();
//				
//				// get correspondent BPMN flow and paint the flow arrow
//					Flow flow = (Flow) outEdge;
//					ActivityDecoratorData activityDecoratorData = activityDecorationMap.get(bpmnNode);
//					int frequency = 0;
//					if (activityDecoratorData != null) {
//						frequency = activityDecorationMap.get(bpmnNode).getFrequency();
//					}
//					paintArrows(minEdgeFreq, minMaxEdgeDifference, flow, frequency);
//				}
//
//			}
//			if (outNodes.size() == 1) {
//				FlexNode outNode = outNodes.get(0);
//
//				// get frequency
//				Pair<Short, Short> shortRepresentation = new Pair<Short, Short>(codec.encode(flexNode),
//						codec.encode(outNode));
//				EdgeInstance edgeInstance = instanceMap.get(shortRepresentation);
//				int frequency = 0;
//				if (edgeInstance != null) {
//					frequency = edgeInstance.getFrequency();
//				}
//				// get correspondent BPMN flow
//				FlexEdge<? extends FlexNode, ? extends FlexNode> flexEdge = flex.getOutEdges(flexNode).iterator()
//						.next();
//				Flow flow = (Flow) flexBPMNEdgeMapping.get(flexEdge);
//
//				paintArrows(minEdgeFreq, minMaxEdgeDifference, flow, frequency);
//			}
//			if (outNodes.size() > 1) {
//				// get correspondant bpmn node
//				BPMNNode bpmnNode = flexBPMNNodeMapping.get(flexNode);
//
//				// get edge to the gateway
//				BPMNEdge<? extends BPMNNode, ? extends BPMNNode> outEdge = bpmn.getOutEdges(bpmnNode).iterator().next();
//
//				// get correspondent BPMN flow and paint the flow arrow
//				Flow flow = (Flow) outEdge;
//				ActivityDecoratorData activityDecoratorData = activityDecorationMap.get(bpmnNode);
//				int frequency = 0;
//				if (activityDecoratorData != null) {
//					frequency = activityDecoratorData.getFrequency();
//				}
//				paintArrows(minEdgeFreq, minMaxEdgeDifference, flow, frequency);
//
//				BPMNNode bpmnNodeGateway = outEdge.getTarget();
//
//				for (BPMNEdge<? extends BPMNNode, ? extends BPMNNode> bpmnNodeGatewayEdge : bpmn
//						.getOutEdges(bpmnNodeGateway)) {
//					BPMNNode bpmnNode2 = bpmnNodeGatewayEdge.getTarget();
//					FlexNode flexNode2 = bpmnFlexNodeMapping.get(bpmnNode2);
//					if ((bpmnNode2 instanceof Activity) && (flexNode2 != null)){
//						// get frequency
//						Pair<Short, Short> shortRepresentation = new Pair<Short, Short>(codec.encode(flexNode),
//								codec.encode(flexNode2));
//						EdgeInstance edgeInstance = instanceMap.get(shortRepresentation);
//						frequency = 0;
//						if (edgeInstance != null) {
//							frequency = edgeInstance.getFrequency();
//						}
//						// get correspondent BPMN flow
//						Flow flow2 = (Flow) bpmnNodeGatewayEdge;
//						paintArrows(minEdgeFreq, minMaxEdgeDifference, flow2, frequency);
//
//						FlowDecoratorData data = new FlowDecoratorData();
//						data.setFrequency(frequency);
//						if (activityDecoratorData != null) {
//							data.setProbability((double) frequency / activityDecoratorData.getFrequency());
//						}
//						flow2.setDecorator(new FlowDecorator(data));
//						paintArrows2(flow2, data.getProbability());
//
//					} else {
//						// gateway then
//						Collection<BPMNEdge<? extends BPMNNode, ? extends BPMNNode>> bpmnEdges = bpmn
//								.getOutEdges(bpmnNode2);
//						if (bpmnEdges.size() > 1) {
//							// split gateway and it has to be AND gateway according to our implementation in C-net to BPMN conversion
//
//							// get frequency of one of the flexnodes because it has AND gateway
//							//The AND gateway can be connected to directly to BPMN Acitivity Node or 
//							//there can be a join gateway in front of the activity nod so it can be connected to that node.
//							//1. Check whether the node is activity node or gateway node
//							//2. If it is BPMN activity node, then get its Flexnode
//							//3. If it is BPMN gateway node(should be a join gateway), then get its connecting BPMN Activity Node(outedge.target).
//							BPMNNode targetBPMNNodeOfANDGateway = bpmnEdges.iterator().next().getTarget();
//							flexNode2 = null;
//							if (targetBPMNNodeOfANDGateway instanceof Gateway) {
//								//then it is a join gateway so get its outedges and find the bpmn node
//								Collection<BPMNEdge<? extends BPMNNode, ? extends BPMNNode>> targetBPMNNodeOutEdges = bpmn
//										.getOutEdges(targetBPMNNodeOfANDGateway);
//								BPMNNode targetActivityOfANDGateway = targetBPMNNodeOutEdges.iterator().next()
//										.getTarget();
//								flexNode2 = bpmnFlexNodeMapping.get(targetActivityOfANDGateway);
//							} else {
//								flexNode2 = bpmnFlexNodeMapping.get(targetBPMNNodeOfANDGateway);
//							}
//							Pair<Short, Short> shortRepresentation = new Pair<Short, Short>(codec.encode(flexNode),
//									codec.encode(flexNode2));
//							EdgeInstance edgeInstance = instanceMap.get(shortRepresentation);
//							frequency = 0;
//							if (edgeInstance != null) {
//								frequency = edgeInstance.getFrequency();
//							}
//							// get correspondent BPMN flow
//							Flow flow2 = (Flow) bpmnNodeGatewayEdge;
//							paintArrows(minEdgeFreq, minMaxEdgeDifference, flow2, frequency);
//
//							FlowDecoratorData data = new FlowDecoratorData();
//							data.setFrequency(frequency);
//							if ((activityDecoratorData != null) && (frequency != 0)) {
//								data.setProbability(frequency / frequency);
//							}
//							flow2.setDecorator(new FlowDecorator(data));
//							paintArrows2(flow2, data.getProbability());
//							for (BPMNEdge<? extends BPMNNode, ? extends BPMNNode> bpmnEdge : bpmnEdges) {
//								Flow flow3 = (Flow) bpmnEdge;
//								paintArrows(minEdgeFreq, minMaxEdgeDifference, flow3, frequency);
//								FlowDecoratorData data2 = new FlowDecoratorData();
//								data2.setFrequency(frequency);
//								if ((activityDecoratorData != null) && (frequency != 0)) {
//									data2.setProbability(frequency / frequency);
//								}
//								flow3.setDecorator(new FlowDecorator(data2));
//								paintArrows2(flow3, data2.getProbability());
//							}
//						} else {
//							// join gateway
//							flexNode2 = bpmnFlexNodeMapping.get(bpmnEdges.iterator().next().getTarget());
//
//							// get frequency
//							Pair<Short, Short> shortRepresentation = new Pair<Short, Short>(codec.encode(flexNode),
//									codec.encode(flexNode2));
//							EdgeInstance edgeInstance = instanceMap.get(shortRepresentation);
//							frequency = 0;
//							if (edgeInstance != null) {
//								frequency = edgeInstance.getFrequency();
//							}
//
//							// get correspondent BPMN flow
//							Flow flow2 = (Flow) bpmnNodeGatewayEdge;
//							paintArrows(minEdgeFreq, minMaxEdgeDifference, flow2, frequency);
//
//							FlowDecoratorData data = new FlowDecoratorData();
//							data.setFrequency(frequency);
//							if ((activityDecoratorData != null) && (activityDecoratorData.getFrequency() != 0)) {
//								data.setProbability((double) frequency / activityDecoratorData.getFrequency());
//							}
//							flow2.setDecorator(new FlowDecorator(data));
//							paintArrows2(flow2, data.getProbability());
//						}
//
//					}
//				}
//
//			}
//			if (inNodes.size() == 0) {
//				// end event
//				// get correspondant bpmn node
//				BPMNNode bpmnNode = flexBPMNNodeMapping.get(flexNode);
//
//				// get edge to the gateway
//				BPMNEdge<? extends BPMNNode, ? extends BPMNNode> inEdge = bpmn.getInEdges(bpmnNode).iterator().next();
//
//				// get correspondent BPMN flow and paint the flow arrow
//				Flow flow = (Flow) inEdge;
//				ActivityDecoratorData activityDecoratorData = activityDecorationMap.get(bpmnNode);
//				int frequency = 0;
//				if (activityDecoratorData != null) {
//					frequency = activityDecorationMap.get(bpmnNode).getFrequency();
//				}
//				if (flow != null) {
//					paintArrows(minEdgeFreq, minMaxEdgeDifference, flow, frequency);
//				}
//
//			}
//			if (inNodes.size() == 1) {
//				FlexNode inNode = inNodes.get(0);
//
//				// get frequency
//				Pair<Short, Short> shortRepresentation = new Pair<Short, Short>(codec.encode(inNode),
//						codec.encode(flexNode));
//				EdgeInstance edgeInstance = instanceMap.get(shortRepresentation);
//				int frequency = 0;
//				if (edgeInstance != null) {
//					frequency = edgeInstance.getFrequency();
//				}
//				// get correspondent BPMN flow
//				FlexEdge<? extends FlexNode, ? extends FlexNode> flexEdge = flex.getInEdges(flexNode).iterator().next();
//				Flow flow = (Flow) flexBPMNEdgeMapping.get(flexEdge);
//				if (flow != null) {
//					paintArrows(minEdgeFreq, minMaxEdgeDifference, flow, frequency);
//				}
//
//			}
//			if (inNodes.size() > 1) {
//				// get correspondant bpmn node
//				BPMNNode bpmnNode = flexBPMNNodeMapping.get(flexNode);
//				if(bpmn.getInEdges(bpmnNode).iterator().hasNext()) {
//				BPMNEdge<? extends BPMNNode, ? extends BPMNNode> bpmnEdge = bpmn.getInEdges(bpmnNode).iterator().next();
//
//				// get correspondent BPMN flow and paint the flow arrow
//				Flow flow = (Flow) bpmnEdge;
//				ActivityDecoratorData activityDecoratorData = activityDecorationMap.get(bpmnNode);
//				int frequency = 0;
//				if (activityDecoratorData != null) {
//					frequency = activityDecorationMap.get(bpmnNode).getFrequency();
//				}
//				paintArrows(minEdgeFreq, minMaxEdgeDifference, flow, frequency);
//
//				BPMNNode bpmnNodeGateway = bpmnEdge.getSource();
//				for (BPMNEdge<? extends BPMNNode, ? extends BPMNNode> bpmnNodeGatewayEdge : bpmn
//						.getInEdges(bpmnNodeGateway)) {
//					BPMNNode bpmnNode2 = bpmnNodeGatewayEdge.getSource();
//					if (bpmnNode2 instanceof Activity) {
//						FlexNode flexNode2 = bpmnFlexNodeMapping.get(bpmnNode2);
//
//						if(flexNode2 != null) {
//							// get frequency
//							Pair<Short, Short> shortRepresentation = new Pair<Short, Short>(codec.encode(flexNode2),
//									codec.encode(flexNode));
//							EdgeInstance edgeInstance = instanceMap.get(shortRepresentation);
//							frequency = 0;
//							if (edgeInstance != null) {
//								frequency = edgeInstance.getFrequency();
//							}
//	
//							// get correspondent BPMN flow
//							Flow flow2 = (Flow) bpmnNodeGatewayEdge;
//							if (flow2 != null) {
//								paintArrows(minEdgeFreq, minMaxEdgeDifference, flow2, frequency);
//							}
//						}
//					} else {
//						// bpmnNode2 gateway then
//						Collection<BPMNEdge<? extends BPMNNode, ? extends BPMNNode>> bpmnEdges = bpmn
//								.getInEdges(bpmnNode2);
//						if (bpmnEdges.size() > 1) {
//							// join gateway and it has to be AND gateway according to our implementation in C-net to BPMN conversion
//
//							// get frequency of one of the flexnodes because it has AND gateway
//							FlexNode flexNode2 = bpmnFlexNodeMapping.get(bpmnEdges.iterator().next().getSource());
//							Pair<Short, Short> shortRepresentation = null;
//							if ((flexNode!= null) && (flexNode2 != null)) {
//								shortRepresentation = new Pair<Short, Short>(codec.encode(flexNode),
//									codec.encode(flexNode2));
//							}
//							EdgeInstance edgeInstance = instanceMap.get(shortRepresentation);
//							frequency = 0;
//							if (edgeInstance != null) {
//								frequency = edgeInstance.getFrequency();
//							}
//							// get correspondent BPMN flow
//							Flow flow2 = (Flow) bpmnNodeGatewayEdge;
//							if (flow2 != null) {
//								paintArrows(minEdgeFreq, minMaxEdgeDifference, flow2, frequency);
//							}
//							for (BPMNEdge<? extends BPMNNode, ? extends BPMNNode> bpmnEdge2 : bpmnEdges) {
//								Flow flow3 = (Flow) bpmnEdge2;
//								paintArrows(minEdgeFreq, minMaxEdgeDifference, flow3, frequency);
//							}
//						} else {
//							// then it is a split gateway so skip this part because we take thi into account in above second condition
//						}
//
//					}
//				}
//
//			}
//			}
//
//		}
//	}
//
//	/*
//	 * Paint Events
//	 */
//	private Map<Event, EventDecoratorData> decorEvents(Map<Activity, ActivityDecoratorData> activityDecorationMap) {
//		Map<Event, EventDecoratorData> eventDecorationMap = new HashMap<Event, EventDecoratorData>();
//		for (Event event : bpmn.getEvents()) {
//			viewSpecificMap.putViewSpecific(event, AttributeMap.FILLCOLOR, Color.LIGHT_GRAY);
//			if (event.getEventType().equals(EventType.START)) {
//				BPMNEdge<? extends BPMNNode, ? extends BPMNNode> bpmnEdge = bpmn.getOutEdges(event).iterator().next();
//				Flow flow = (Flow) bpmnEdge;
//				BPMNNode bpmnNode = flow.getTarget();
//				ActivityDecoratorData data = activityDecorationMap.get(bpmnNode);
//				// SET EVENT DECORATION
//				EventDecoratorData eventDecoratorData = new EventDecoratorData();
//
//				if (data == null) {
//					eventDecoratorData.setFrequency(0);
//				} else {
//					eventDecoratorData.setFrequency(data.getFrequency());
//				}
//				eventDecoratorData.setArrivalRate(getSelectedBPMNAnalysisData().getArrivalRate());
//				eventDecorationMap.put(event, eventDecoratorData);
//				event.setDecorator(new EventDecorator(eventDecoratorData));
//
//			} else if (event.getEventType().equals(EventType.END)) {
//				ActivityDecoratorData data = activityDecorationMap.get(bpmn.getInEdges(event).iterator().next()
//						.getSource());
//				EventDecoratorData eventDecoratorData = new EventDecoratorData();
//				if (data == null) {
//					eventDecoratorData.setFrequency(0);
//				} else {
//					eventDecoratorData.setFrequency(data.getFrequency());
//				}
//				eventDecorationMap.put(event, eventDecoratorData);
//				event.setDecorator(new EventDecorator(eventDecoratorData));
//			}
//		}
//		return eventDecorationMap;
//	}
//
//	/*
//	 * Paint Flows
//	 */
//	private void paintArrows(int minEdgeFreq, int minMaxEdgeDifference, Flow bpmnFlow, int frequency) {
//
//		if (frequency == 0) {
//			viewSpecificMap.putViewSpecific(bpmnFlow, AttributeMap.EDGECOLOR,  Color.BLACK);
//			viewSpecificMap.putViewSpecific(bpmnFlow, AttributeMap.LINEWIDTH, MINARCWIDTH);
//		} else {
//			viewSpecificMap.removeViewSpecific(bpmnFlow, AttributeMap.SHOWLABEL);
//			viewSpecificMap.removeViewSpecific(bpmnFlow, AttributeMap.LABEL);
//			viewSpecificMap.removeViewSpecific(bpmnFlow, AttributeMap.LABELCOLOR);
//			viewSpecificMap.putViewSpecific(bpmnFlow, AttributeMap.LABELCOLOR, Color.BLACK);
//			viewSpecificMap.putViewSpecific(bpmnFlow, AttributeMap.SHOWLABEL, true);
//			viewSpecificMap.putViewSpecific(bpmnFlow, AttributeMap.LABEL, "" + frequency);
//			viewSpecificMap.putViewSpecific(bpmnFlow, AttributeMap.EDGECOLOR, Color.BLACK);
//			
//			StringBuffer additionalText = new StringBuffer("<html><table border=0>"
//					+ "<tr><td><b>Frequency:</b><br/></td><td>" + frequency + "</td></tr>");
//			viewSpecificMap.putViewSpecific(bpmnFlow, AttributeMap.TOOLTIP, additionalText.append("</table></html>")
//					.toString());
//
//			float newSize = 0;
//			if (minMaxEdgeDifference != 0) {
//				float additionalWidth = ((frequency - minEdgeFreq) * MAXARCADDITIONWIDTH) / minMaxEdgeDifference;
//				newSize = MINARCWIDTH + ((additionalWidth > 5) ? 6 : additionalWidth);
//			} else {
//				newSize = MAXARCADDITIONWIDTH;
//			}
//			viewSpecificMap.putViewSpecific(bpmnFlow, AttributeMap.LINEWIDTH, newSize);
//		}
//	}
//
//	/*
//	 * Paint Flows (include probability if needed)
//	 */
//	private void paintArrows2(Flow bpmnFlow, double probability) {
//		String string = (String) viewSpecificMap.get(bpmnFlow, AttributeMap.TOOLTIP);
//		if (string != null) {
//			if (string.indexOf("</table></html>") > 0) {
//				StringBuffer additionalText = new StringBuffer(string.substring(0, string.indexOf("</html>")));
//				additionalText.append("<tr><td><b>Probability:</b><br/></td><td>" + probability + "</td></tr>");
//				viewSpecificMap.putViewSpecific(bpmnFlow, AttributeMap.TOOLTIP, additionalText
//						.append("</table></html>").toString());
//			}
//		}
//	}
//
//	/*
//	 * Color Gateways
//	 */
//	private void decorGateways(Map<Activity, ActivityDecoratorData> activityDecorationMap,
//			Map<Event, EventDecoratorData> eventDecorationMap) {
//		FlexPerfRepInfo perfResult = getSelectedBPMNAnalysisData().getPerfRepInfo();
//
//		// Decoring Gateways
//		for (Gateway gateway : bpmn.getGateways()) {
//			viewSpecificMap.putViewSpecific(gateway, AttributeMap.FILLCOLOR, Color.LIGHT_GRAY);
//			Collection<BPMNEdge<? extends BPMNNode, ? extends BPMNNode>> inEdgesCollection = bpmn.getInEdges(gateway);
//			Collection<BPMNEdge<? extends BPMNNode, ? extends BPMNNode>> outEdgesCollection = bpmn.getOutEdges(gateway);
//			int frequency = perfResult.getCaseInstance().getFrequency();
//			if (inEdgesCollection.size() == 1) {
//				BPMNNode bpmnNode = inEdgesCollection.iterator().next().getSource();
//
//				if (bpmnNode instanceof Gateway) {
//					Collection<BPMNEdge<? extends BPMNNode, ? extends BPMNNode>> inEdgesCollection2 = bpmn
//							.getInEdges(bpmnNode);
//					BPMNNode bpmnNode2 = inEdgesCollection2.iterator().next().getSource();
//					// no more iteration between gateways
//					if (bpmnNode2 instanceof Event) {
//						EventDecoratorData eventDecoratorData = eventDecorationMap.get(bpmnNode2);
//						GatewayDecoratorData gatewayDecoratorData = new GatewayDecoratorData();
//						gatewayDecoratorData.setFrequency(eventDecoratorData.getFrequency());
//						if (frequency != 0) {
//							gatewayDecoratorData.setCaseInvolvementRatio(gatewayDecoratorData.getFrequency()
//									/ frequency);
//						} else {
//							gatewayDecoratorData.setCaseInvolvementRatio(0);
//						}
//						gateway.setDecorator(new GatewayDecorator(gatewayDecoratorData));
//					} else if (bpmnNode2 instanceof Activity) {
//						Activity activity = (Activity) bpmnNode2;
//						ActivityDecoratorData data = activityDecorationMap.get(activity);
//						GatewayDecoratorData gatewayDecoratorData = new GatewayDecoratorData();
//						gatewayDecoratorData.setFrequency((data != null) ? data.getFrequency() : 0);
//						if (frequency != 0) {
//							gatewayDecoratorData.setCaseInvolvementRatio(gatewayDecoratorData.getFrequency()
//									/ frequency);
//						} else {
//							gatewayDecoratorData.setCaseInvolvementRatio(0);
//						}
//						gateway.setDecorator(new GatewayDecorator(gatewayDecoratorData));
//					}
//				} else if (bpmnNode instanceof Event) {
//					EventDecoratorData eventDecoratorData = eventDecorationMap.get(bpmnNode);
//					GatewayDecoratorData gatewayDecoratorData = new GatewayDecoratorData();
//					gatewayDecoratorData.setFrequency(eventDecoratorData.getFrequency());
//					if (frequency != 0) {
//						gatewayDecoratorData.setCaseInvolvementRatio(gatewayDecoratorData.getFrequency() / frequency);
//					} else {
//						gatewayDecoratorData.setCaseInvolvementRatio(0);
//					}
//					gateway.setDecorator(new GatewayDecorator(gatewayDecoratorData));
//				} else if (bpmnNode instanceof Activity) {
//					Activity activity = (Activity) bpmnNode;
//					ActivityDecoratorData data = activityDecorationMap.get(activity);
//					GatewayDecoratorData gatewayDecoratorData = new GatewayDecoratorData();
//					gatewayDecoratorData.setFrequency((data != null) ? data.getFrequency() : 0);
//					if (frequency != 0) {
//						gatewayDecoratorData.setCaseInvolvementRatio(gatewayDecoratorData.getFrequency() / frequency);
//					} else {
//						gatewayDecoratorData.setCaseInvolvementRatio(0);
//					}
//					gateway.setDecorator(new GatewayDecorator(gatewayDecoratorData));
//				}
//
//			}
//			if (outEdgesCollection.size() == 1) {
//				BPMNNode bpmnNode = outEdgesCollection.iterator().next().getTarget();
//				if (bpmnNode instanceof Gateway) {
//					Collection<BPMNEdge<? extends BPMNNode, ? extends BPMNNode>> outEdgesCollection2 = bpmn
//							.getOutEdges(bpmnNode);
//					BPMNNode bpmnNode2 = outEdgesCollection2.iterator().next().getSource();
//					// no more iteration between gateways
//					if (bpmnNode2 instanceof Event) {
//						EventDecoratorData eventDecoratorData = eventDecorationMap.get(bpmnNode2);
//						GatewayDecoratorData gatewayDecoratorData = new GatewayDecoratorData();
//						gatewayDecoratorData.setFrequency(eventDecoratorData.getFrequency());
//						if (frequency != 0) {
//							gatewayDecoratorData.setCaseInvolvementRatio(gatewayDecoratorData.getFrequency()
//									/ frequency);
//						} else {
//							gatewayDecoratorData.setCaseInvolvementRatio(0);
//						}
//						gateway.setDecorator(new GatewayDecorator(gatewayDecoratorData));
//					} else if (bpmnNode2 instanceof Activity) {
//						Activity activity = (Activity) bpmnNode2;
//						ActivityDecoratorData data = activityDecorationMap.get(activity);
//						GatewayDecoratorData gatewayDecoratorData = new GatewayDecoratorData();
//						gatewayDecoratorData.setFrequency((data != null) ? data.getFrequency() : 0);
//						if (frequency != 0) {
//							gatewayDecoratorData.setCaseInvolvementRatio(gatewayDecoratorData.getFrequency()
//									/ frequency);
//						} else {
//							gatewayDecoratorData.setCaseInvolvementRatio(0);
//						}
//						gateway.setDecorator(new GatewayDecorator(gatewayDecoratorData));
//					}
//				} else if (bpmnNode instanceof Event) {
//					EventDecoratorData eventDecoratorData = eventDecorationMap.get(bpmnNode);
//					GatewayDecoratorData gatewayDecoratorData = new GatewayDecoratorData();
//					gatewayDecoratorData.setFrequency(eventDecoratorData.getFrequency());
//					if (frequency != 0) {
//						gatewayDecoratorData.setCaseInvolvementRatio(gatewayDecoratorData.getFrequency() / frequency);
//					} else {
//						gatewayDecoratorData.setCaseInvolvementRatio(0);
//					}
//					gateway.setDecorator(new GatewayDecorator(gatewayDecoratorData));
//				} else if (bpmnNode instanceof Activity) {
//					Activity activity = (Activity) bpmnNode;
//					ActivityDecoratorData data = activityDecorationMap.get(activity);
//					GatewayDecoratorData gatewayDecoratorData = new GatewayDecoratorData();
//					gatewayDecoratorData.setFrequency((data != null) ? data.getFrequency() : 0);
//					if (frequency != 0) {
//						gatewayDecoratorData.setCaseInvolvementRatio(gatewayDecoratorData.getFrequency() / frequency);
//					} else {
//						gatewayDecoratorData.setCaseInvolvementRatio(0);
//					}
//					gateway.setDecorator(new GatewayDecorator(gatewayDecoratorData));
//				}
//			}
//		}
//	}
//
//	/*
//	 * get green, red, yellow color which indicates low, high or moderate value
//	 * respectively
//	 */
//	private Color getColor(Double val, double lowBound, double upBound) {
//		if (Double.compare(Double.NaN, val) == 0) {
//			return Color.GREEN;
//		} else {
//			if (Double.compare(val, lowBound) <= 0) {
//				return Color.GREEN;
//			} else if (Double.compare(val, upBound) <= 0) {
//				return Color.YELLOW;
//			} else {
//				return Color.RED;
//			}
//		}
//	}
//
//	/*
//	 * Sort the given array
//	 */
//	private double[] getSortedArrayFromSet(Set<Double> sumNodeAvgWorkingTime) {
//		double[] arrSumNodeAvgWorking = new double[sumNodeAvgWorkingTime.size()];
//		int counter = 0;
//		for (double value : sumNodeAvgWorkingTime) {
//			arrSumNodeAvgWorking[counter] = value;
//			counter++;
//		}
//		Arrays.sort(arrSumNodeAvgWorking);
//		return arrSumNodeAvgWorking;
//	}
//
//	/*
//	 * Uncolor the elements of BPMN model
//	 */
//	private void uncolorElements() {
//		ProMJGraph graph = proMJGraphPanel.getGraph();
//
//		for (Activity activityNode : bpmn.getActivities()) {
//			activityNode.setDecorator(null);
//
//			// set the attributes
//			viewSpecificMap.putViewSpecific(activityNode, AttributeMap.FILLCOLOR, Color.WHITE);
//			viewSpecificMap.putViewSpecific(activityNode, AttributeMap.SHOWLABEL, false);
//			viewSpecificMap.putViewSpecific(activityNode, AttributeMap.SIZE, new Dimension(NODEWIDTH, NODEHEIGHT));
//			activityNode.getAttributeMap().put(AttributeMap.SIZE, new Dimension(140, 80));
//
//		}
//		for (Gateway gatewayNode : bpmn.getGateways()) {
//			gatewayNode.setDecorator(null);
//
//			// set the attributes
//			viewSpecificMap.putViewSpecific(gatewayNode, AttributeMap.FILLCOLOR, Color.WHITE);
//			viewSpecificMap.putViewSpecific(gatewayNode, AttributeMap.SHOWLABEL, false);
//			viewSpecificMap.putViewSpecific(gatewayNode, AttributeMap.SIZE, new Dimension((NODEWIDTH + NODEHEIGHT) / 2,
//					(NODEWIDTH + NODEHEIGHT) / 2));
//			
//			gatewayNode.getAttributeMap().put(AttributeMap.SIZE, new Dimension((NODEWIDTH + NODEHEIGHT) / 2,
//					(NODEWIDTH + NODEHEIGHT) / 2));
//		}
//		for (Event eventNode : bpmn.getEvents()) {
//			eventNode.setDecorator(null);
//
//			// set the attributes
//			viewSpecificMap.putViewSpecific(eventNode, AttributeMap.FILLCOLOR, Color.WHITE);
//			viewSpecificMap.putViewSpecific(eventNode, AttributeMap.SHOWLABEL, false);
//			viewSpecificMap.putViewSpecific(eventNode, AttributeMap.SIZE, new Dimension(NODEHEIGHT, NODEHEIGHT));
//			eventNode.getAttributeMap().put(AttributeMap.SIZE, new Dimension(NODEHEIGHT, NODEHEIGHT));
//		}
//
//		fillMapAndRefreshEdges(Color.BLACK);
//
//		// refresh the figure
//		//graph.setBounds(new Rectangle(new Dimension(1000,1000)));
//		graph.update(bpmn.getNodes());
//		graph.update(bpmn.getEdges());
//		
//		graphPanel.removeAll();
//		proMJGraphPanel = ProMJGraphVisualizer.instance().visualizeGraphWithoutRememberingLayout(bpmn);
//		BPMNAnalysisDataList BPMNAnalysisList = null;
//		try {
//			BPMNAnalysisConnection BPMNConnection = context.getConnectionManager()
//					.getFirstConnection(BPMNAnalysisConnection.class, context, bpmn);
//			BPMNAnalysisList = (BPMNAnalysisDataList) BPMNConnection
//				.getObjectWithRole(BPMNAnalysisConnection.BPMNAnalysisList);
//		} catch(Exception e) {
//			e.printStackTrace();
//		}
//		initVisualization(BPMNAnalysisList, proMJGraphPanel);
//	}
//
//	/*
//	 * Update viewSpecificMap for Flow objects
//	 */
//	private void fillMapAndRefreshEdges(Color color) {
//		ProMJGraph graph = proMJGraphPanel.getGraph();
//
//		for (Flow flow : bpmn.getFlows()) {
//			flow.setDecorator(null);
//			viewSpecificMap.removeViewSpecific(flow, AttributeMap.SHOWLABEL);
//			viewSpecificMap.putViewSpecific(flow, AttributeMap.SHOWLABEL, false);
//			// set the attributes
//			viewSpecificMap.putViewSpecific(flow, AttributeMap.EDGECOLOR, color);
//			viewSpecificMap.putViewSpecific(flow, AttributeMap.LINEWIDTH, NORMALLINEWIDTH);
//			viewSpecificMap.removeViewSpecific(flow, AttributeMap.TOOLTIP);
//		}
//		graph.update(bpmn.getEdges());
//	}
//
//	public void setViewSpecificMap(ProMJGraphPanel proMJGraphPanel) {
//
//	}
//
//	/**
//	 * Panels to interactively change the swimlanes with a threshold slider
//	 */
//	@SuppressWarnings("unused")
//	private void initSwimlanePanel() {
//		JPanel sliderPanel = new JPanel();
//		sliderPanel.setLayout(null);
//		sliderPanel.setSize(150, 365);
//		sliderPanel.setLocation(0, 0);
//		JLabel sliderInfo = new JLabel("Number of Executions by Users Threshold");
//		sliderInfo.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//		sliderInfo.setForeground(Color.DARK_GRAY);
//		sliderInfo.setUI(new VerticalLabelUI(false));
//		sliderInfo.setHorizontalTextPosition(SwingConstants.CENTER);
//		sliderInfo.setVerticalTextPosition(SwingConstants.CENTER);
//
//		swimlaneSlider = SlickerFactory.instance().createSlider(1);
//
//		swimlaneSlider.setMinimum(0);
//		swimlaneSlider.setValue(0);
//		swimlaneSlider.setMaximum(100);
//
//		swimlaneSlider.addChangeListener(new ChangeListener() {
//			public void stateChanged(ChangeEvent e) {
//				updateBPMNModel(true);
//			}
//		});
//
//		sliderMinValue = SlickerFactory.instance().createLabel("%0");
//		sliderMaxValue = SlickerFactory.instance().createLabel("%100");
//
//		sliderValue = SlickerFactory.instance().createLabel("%0");
//
//		sliderMinValue.setHorizontalAlignment(SwingConstants.CENTER);
//		sliderMaxValue.setHorizontalAlignment(SwingConstants.CENTER);
//		sliderValue.setHorizontalAlignment(SwingConstants.LEFT);
//
//		sliderMinValue.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//		sliderMaxValue.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//		sliderValue.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//
//		sliderMinValue.setForeground(Color.DARK_GRAY);
//		sliderMaxValue.setForeground(Color.DARK_GRAY);
//		sliderValue.setForeground(Color.DARK_GRAY);
//
//		int height = 365;
//		int sliderHeight = height - 65;
//
//		sliderInfo.setBounds(20, 45, 20, sliderHeight - 60);
//		this.swimlaneSlider.setBounds(75, 25, 20, sliderHeight);
//		this.sliderMaxValue.setBounds(65, 10, 60, 20);
//		this.sliderMinValue.setBounds(65, height - 40, 40, 20);
//
//		int span = this.swimlaneSlider.getMaximum() - this.swimlaneSlider.getMinimum();
//		int position = 33 + (int) ((float) (this.swimlaneSlider.getMaximum() - 50) / (float) span * (sliderHeight - 28));
//		this.sliderValue.setBounds(95, position, 60, 20);
//
//		sliderPanel.setBackground(Color.LIGHT_GRAY);
//		sliderPanel.add(sliderInfo);
//		sliderPanel.add(swimlaneSlider);
//		sliderPanel.add(sliderMinValue);
//		sliderPanel.add(sliderMaxValue);
//		sliderPanel.add(sliderValue);
//
//		JPanel applyPanel = new JPanel();
//		applyPanel.setLocation(0, 365);
//		applyPanel.setLayout(null);
//		applyPanel.setSize(150, 35);
//		JButton applyButton = new JButton("Apply Swimlane");
//		applyButton.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
//		applyButton.setForeground(Color.DARK_GRAY);
//		applyButton.setBackground(new Color(238, 238, 238));
//		applyButton.setHorizontalAlignment(SwingConstants.CENTER);
//		applyButton.setVerticalAlignment(SwingConstants.CENTER);
//		applyButton.setSize(130, 20);
//		applyButton.setLocation(5, 5);
//		applyButton.setBounds(5, 5, 130, 20);
//		applyButton.addActionListener(new ActionListener() {
//
//			@Override
//			public void actionPerformed(ActionEvent e) {
//				updateBPMNModel(false);
//
//			}
//		});
//		applyPanel.add(applyButton);
//
//		swimlaneConfigurationPanel = new PerfConfInteractionPanel(proMJGraphPanel, "Swimlane", sliderPanel, applyPanel,
//				150, 400, PerfConfInteractionPanel.LEFT_BOTTOM);
//
//	}
//
//	/*
//	 * Update BPMN model in order to update swimlanes with the new threshold
//	 * settings
//	 */
//	public void updateBPMNModel(boolean b) {
//		@SuppressWarnings("unused")
//		Map<String, Map<String, Integer>> userActivityPercentageMap = getSelectedBPMNAnalysisData()
//				.getUserActivityPercentageMap();
//
//		if (b) {
//			int value = this.swimlaneSlider.getValue();
//			this.sliderValue.setText("%" + value);
//
//		} else {
//			bpmn.getSwimlanes().clear();
//
//			Swimlane s = bpmn.addSwimlane("Test", null);
//			for (BPMNNode bpmnNode : bpmn.getNodes()) {
//				if (!s.equals(bpmnNode)) {
//					bpmnNode.setParentSwimlane(s);
//				}
//			}
//
//			/*
//			 * graphPanel =
//			 * ProMJGraphVisualizer.instance().visualizeGraph(context, bpmn);
//			 * graph = graphPanel.getGraph(); graphPanel.getGraph().setModel(new
//			 * ProMGraphModel(bpmn)); graph.update(bpmn.getNodes());
//			 * graph.repaint();
//			 * 
//			 * 
//			 * JComponent c = graph.getComponent(); Component[] c2 =
//			 * c.getComponents(); ProMJGraphPanel proMJGraphPanel =
//			 * ProMJGraphVisualizer.instance().visualizeGraph(context, bpmn);
//			 * graphPanel.getGraph().removeAll();
//			 * graphPanel.getGraph().add(proMJGraphPanel.getGraph());
//			 * graph.repositionToOrigin(); graphPanel.repaint();
//			 * graph.update(bpmn.getNodes()); graph.update(bpmn.getEdges());
//			 */
//
//		}
//
//	}
//
//	/*
//	 * TODO: Implement demonstration of deviations Update BPMN model in order to
//	 * show deviations: NOT IMPLEMENTED YET
//	 */
//	@SuppressWarnings("unused")
//	private void updateGraph() {
//
//		graphPanel.removeAll();
//		ProMJGraphPanel proMJGraphPanel = ProMJGraphVisualizer.instance().visualizeGraphWithoutRememberingLayout(bpmn);
//		String message = "";
//		ConnectionManager conn = context.getConnectionManager();
//		try {
//			message = "BPMNAnalysisConnection";
//			BPMNAnalysisConnection BPMNConnection = conn
//					.getFirstConnection(BPMNAnalysisConnection.class, context, bpmn);
//
//			Flex flex = (Flex) BPMNConnection.getObjectWithRole(BPMNAnalysisConnection.FLEX);
//			BPMNAnalysisDataList BPMNAnalysisList = (BPMNAnalysisDataList) BPMNConnection
//					.getObjectWithRole(BPMNAnalysisConnection.BPMNAnalysisList);
//
//			message = "FlexCodecConnection";
//			FlexCodecConnection codecConn = conn.getFirstConnection(FlexCodecConnection.class, context, flex);
//			FlexCodec codec = (FlexCodec) codecConn.getObjectWithRole(FlexCodecConnection.FLEXCODEC);
//
//			// Legend Panel
//			LegendInteractionPanel legendInteractionPanel = new LegendInteractionPanel(proMJGraphPanel, "Legend");
//			proMJGraphPanel.addViewInteractionPanel(legendInteractionPanel, SwingConstants.NORTH);
//
//			CompoundViewInteractionPanel projection = new CompoundViewInteractionPanel("Projection");
//
//			if (projection.length() > 0) {
//				proMJGraphPanel.addViewInteractionPanel(projection, SwingConstants.SOUTH);
//			}
//
//		} catch (ConnectionCannotBeObtained e) {
//			e.printStackTrace();
//			System.out.println("Exception occured while obtaining " + message);
//		}
//
//		graphPanel.add(proMJGraphPanel, BorderLayout.CENTER);
//		graphPanel.validate();
//		graphPanel.repaint();
//
//	}
//
//}
