package org.processmining.plugins.bpmn.analysis.swimlanes.ui;

import java.awt.Color;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.SwingConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import com.fluxicon.slickerbox.factory.SlickerDecorator;
import com.fluxicon.slickerbox.factory.SlickerFactory;

/**
 * @author ibayraktar
 * 
 */
public class SwimlaneSettingsGUI extends JPanel{
	private static final long serialVersionUID = -2608532190536549047L;
	private JPanel sliderPanel;
	SlickerFactory factory = SlickerFactory.instance();
	SlickerDecorator decorator = SlickerDecorator.instance();
	JSlider swimlaneSlider;
	JLabel sliderValue;

	int mostFrequent = 3;
	int leastFrequent = 3;
	int mostTimeConsuming = 3;
	int leastTimeConsuming = 3;

	
	public SwimlaneSettingsGUI() {
		this.setLayout(null);
		this.initSwimlanePanel();
	}

	/**
	 * 
	 */
	private void initSwimlanePanel() {
		sliderPanel = factory.createRoundedPanel(15, Color.LIGHT_GRAY);
		this.sliderPanel.setBounds(0, 0, 770, 120);
		sliderPanel.setLayout(null);
		sliderPanel.setSize(770, 120);
		sliderPanel.setLocation(0, 0);

		JLabel sliderPanelTitle = factory.createLabel("Swimlane Threshold Selection");
		sliderPanelTitle.setHorizontalAlignment(SwingConstants.CENTER);
		sliderPanelTitle.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 18));
		sliderPanelTitle.setForeground(new Color(40, 40, 40));

		JLabel sliderInfo = new JLabel("Number of Executions by Users Threshold : ");
		sliderInfo.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
		sliderInfo.setForeground(Color.DARK_GRAY);
		sliderInfo.setHorizontalTextPosition(SwingConstants.CENTER);
		sliderInfo.setVerticalTextPosition(SwingConstants.CENTER);

		swimlaneSlider = SlickerFactory.instance().createSlider(0);

		swimlaneSlider.setMinimum(0);
		swimlaneSlider.setValue(0);
		swimlaneSlider.setMaximum(100);

		swimlaneSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				int value = swimlaneSlider.getValue();
				sliderValue.setText("%" + value);
			}
		});

		JLabel sliderMinValue = SlickerFactory.instance().createLabel("%0");
		JLabel sliderMaxValue = SlickerFactory.instance().createLabel("%100");

		sliderValue = SlickerFactory.instance().createLabel("%0");

		sliderMinValue.setHorizontalAlignment(SwingConstants.CENTER);
		sliderMaxValue.setHorizontalAlignment(SwingConstants.CENTER);
		sliderValue.setHorizontalAlignment(SwingConstants.LEFT);
		sliderInfo.setHorizontalAlignment(SwingConstants.LEFT);

		sliderMinValue.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
		sliderMaxValue.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));
		sliderValue.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 12));

		sliderMinValue.setForeground(Color.DARK_GRAY);
		sliderMaxValue.setForeground(Color.DARK_GRAY);
		sliderValue.setForeground(Color.DARK_GRAY);

		int sliderWidth = 300;

		sliderPanelTitle.setBounds(10, 10, 750, 30);

		sliderInfo.setBounds(10, 60, 290, 20);
		swimlaneSlider.setBounds(350, 60, sliderWidth, 20);
		sliderMaxValue.setBounds(660, 60, 60, 20);
		sliderMinValue.setBounds(300, 60, 40, 20);

		int span = swimlaneSlider.getMaximum() - swimlaneSlider.getMinimum();
		int position = 333 + (int) ((float) (swimlaneSlider.getMaximum() - 50) / (float) span * (sliderWidth - 28));
		sliderValue.setBounds(position, 80, 60, 20);

		
		sliderPanel.add(sliderPanelTitle);
		sliderPanel.add(sliderInfo);
		sliderPanel.add(swimlaneSlider);
		sliderPanel.add(sliderMinValue);
		sliderPanel.add(sliderMaxValue);
		sliderPanel.add(sliderValue);

		this.add(this.sliderPanel);
		this.validate();
		this.repaint();
	}
	
	public int getSliderValue() {
		return swimlaneSlider.getValue();
	}

}
