package org.processmining.plugins.bpmn.analysis.utils;

import java.util.UUID;

public class Triple<F, S, T> {

	protected final S second;
	protected final F first;
	protected final T third;

	public Triple(F first, S second, T third) {
		this.first = first;
		this.second = second;
		this.third = third;
	}

	public F getFirst() {
		return first;
	}

	public S getSecond() {
		return second;
	}

	public T getThird() {
		return third;
	}

	private static boolean equals(Object x, Object y) {
		return ((x == null) && (y == null)) || ((x != null) && x.equals(y));
	}

	@SuppressWarnings("unchecked")
	@Override
	public boolean equals(Object other) {
		return (other instanceof Triple) && equals(first, ((Triple<F, S, T>) other).first) && equals(second, ((Triple<F, S, T>) other).second)
				&& equals(third, ((Triple<F, S, T>) other).third);
	}

	@Override
	public int hashCode() {
		return UUID.randomUUID().hashCode();
	}

	@Override
	public String toString() {
		return "(" + first + "," + second + "," + third + ")";
	}

}
